searchNodes=[{"doc":"Module containing functions for constructing and supervising pipelines.Pipelines are units that make it possible to instantiate, link and manage elements and bins in convenient way (actually they should always be used inside a pipeline). Linking pipeline children together enables them to pass data to one another, and process it in different ways.To create a pipeline, use the __using__/1 macro and implement callbacks of Membrane.Pipeline behaviour. For details on instantiating and linking children, see Membrane.ParentSpec.","ref":"Membrane.Pipeline.html","title":"Membrane.Pipeline","type":"behaviour"},{"doc":"Brings all the stuff necessary to implement a pipeline.Options::bring_spec? - if true (default) imports and aliases Membrane.ParentSpec:bring_pad? - if true (default) requires and aliases Membrane.Pad","ref":"Membrane.Pipeline.html#__using__/1","title":"Membrane.Pipeline.__using__/1","type":"macro"},{"doc":"Callback invoked when a child element finishes processing stream via given pad.","ref":"Membrane.Pipeline.html#c:handle_element_end_of_stream/3","title":"Membrane.Pipeline.handle_element_end_of_stream/3","type":"callback"},{"doc":"Callback invoked when a child element starts processing stream via given pad.","ref":"Membrane.Pipeline.html#c:handle_element_start_of_stream/3","title":"Membrane.Pipeline.handle_element_start_of_stream/3","type":"callback"},{"doc":"Callback invoked on initialization of pipeline process. It should parse options and initialize pipeline's internal state. Internally it is invoked inside GenServer.init/1 callback.","ref":"Membrane.Pipeline.html#c:handle_init/1","title":"Membrane.Pipeline.handle_init/1","type":"callback"},{"doc":"Callback invoked when a notification comes in from an element.","ref":"Membrane.Pipeline.html#c:handle_notification/4","title":"Membrane.Pipeline.handle_notification/4","type":"callback"},{"doc":"Callback invoked when pipeline receives a message that is not recognized as an internal membrane message.Useful for receiving ticks from timer, data sent from NIFs or other stuff.","ref":"Membrane.Pipeline.html#c:handle_other/3","title":"Membrane.Pipeline.handle_other/3","type":"callback"},{"doc":"Callback invoked when pipeline transition from :playing to :prepared state has finished, that is all of its children are prepared to be stopped.","ref":"Membrane.Pipeline.html#c:handle_playing_to_prepared/2","title":"Membrane.Pipeline.handle_playing_to_prepared/2","type":"callback"},{"doc":"Callback invoked when pipeline is in :playing state, i.e. all its children are in this state.","ref":"Membrane.Pipeline.html#c:handle_prepared_to_playing/2","title":"Membrane.Pipeline.handle_prepared_to_playing/2","type":"callback"},{"doc":"Callback invoked when pipeline is in :playing state, i.e. all its children are in this state.","ref":"Membrane.Pipeline.html#c:handle_prepared_to_stopped/2","title":"Membrane.Pipeline.handle_prepared_to_stopped/2","type":"callback"},{"doc":"Callback invoked when pipeline is shutting down. Internally called in GenServer.terminate/2 callback.Useful for any cleanup required.","ref":"Membrane.Pipeline.html#c:handle_shutdown/2","title":"Membrane.Pipeline.handle_shutdown/2","type":"callback"},{"doc":"Callback invoked when Membrane.ParentSpec is linked and in the same playback state as pipeline.This callback can be started from handle_init/1 callback or as Membrane.Pipeline.Action.spec_t/0 action.","ref":"Membrane.Pipeline.html#c:handle_spec_started/3","title":"Membrane.Pipeline.handle_spec_started/3","type":"callback"},{"doc":"Callback invoked when pipeline transition from :stopped to :prepared state has finished, that is all of its children are prepared to enter :playing state.","ref":"Membrane.Pipeline.html#c:handle_stopped_to_prepared/2","title":"Membrane.Pipeline.handle_stopped_to_prepared/2","type":"callback"},{"doc":"Callback invoked when pipeline is in :terminating state, i.e. all its children are in this state.","ref":"Membrane.Pipeline.html#c:handle_stopped_to_terminating/2","title":"Membrane.Pipeline.handle_stopped_to_terminating/2","type":"callback"},{"doc":"Callback invoked upon each timer tick. A timer can be started with Membrane.Pipeline.Action.start_timer_t action.","ref":"Membrane.Pipeline.html#c:handle_tick/3","title":"Membrane.Pipeline.handle_tick/3","type":"callback"},{"doc":"Enables to check whether module is membrane pipeline","ref":"Membrane.Pipeline.html#c:membrane_pipeline?/0","title":"Membrane.Pipeline.membrane_pipeline?/0","type":"callback"},{"doc":"Checks whether module is a pipeline.","ref":"Membrane.Pipeline.html#pipeline?/1","title":"Membrane.Pipeline.pipeline?/1","type":"function"},{"doc":"Changes playback state to :playing.An alias for Membrane.Core.PlaybackHandler.change_playback_state/2 with proper state.","ref":"Membrane.Pipeline.html#play/1","title":"Membrane.Pipeline.play/1","type":"function"},{"doc":"Changes playback state to :prepared.An alias for Membrane.Core.PlaybackHandler.change_playback_state/2 with proper state.","ref":"Membrane.Pipeline.html#prepare/1","title":"Membrane.Pipeline.prepare/1","type":"function"},{"doc":"Does the same as start_link/3 but starts process outside of supervision tree.","ref":"Membrane.Pipeline.html#start/3","title":"Membrane.Pipeline.start/3","type":"function"},{"doc":"Starts the Pipeline based on given module and links it to the current process.Pipeline options are passed to module's handle_init/1 callback.Process options are internally passed to GenServer.start_link/3.Returns the same values as GenServer.start_link/3.","ref":"Membrane.Pipeline.html#start_link/3","title":"Membrane.Pipeline.start_link/3","type":"function"},{"doc":"Changes playback state to :stopped.An alias for Membrane.Core.PlaybackHandler.change_playback_state/2 with proper state.","ref":"Membrane.Pipeline.html#stop/1","title":"Membrane.Pipeline.stop/1","type":"function"},{"doc":"Changes pipeline's playback state to :stopped and terminates its process. It accpets two options:blocking? - tells whether to stop the pipeline synchronouslytimeout - if blocking? is set to true it tells how much time (ms) to wait for pipeline to get terminated. Defaults to 5000.","ref":"Membrane.Pipeline.html#stop_and_terminate/2","title":"Membrane.Pipeline.stop_and_terminate/2","type":"function"},{"doc":"","ref":"Membrane.Pipeline.html#t:callback_return_t/0","title":"Membrane.Pipeline.callback_return_t/0","type":"type"},{"doc":"Defines options that can be passed to start/3 / start_link/3 and received in handle_init/1 callback.","ref":"Membrane.Pipeline.html#t:pipeline_options_t/0","title":"Membrane.Pipeline.pipeline_options_t/0","type":"type"},{"doc":"","ref":"Membrane.Pipeline.html#t:state_t/0","title":"Membrane.Pipeline.state_t/0","type":"type"},{"doc":"This module contains type specifications of actions that can be returned from pipeline callbacks.Returning actions is a way of pipeline interaction with other components and parts of framework. Each action may be returned by any callback (except for Membrane.Pipeline.handle_shutdown/2, as it does not support returning any actions) unless explicitly stated otherwise.","ref":"Membrane.Pipeline.Action.html","title":"Membrane.Pipeline.Action","type":"module"},{"doc":"Action that sends a message to a child identified by name.","ref":"Membrane.Pipeline.Action.html#t:forward_t/0","title":"Membrane.Pipeline.Action.forward_t/0","type":"type"},{"doc":"Action that sets Logger metadata for the pipeline and all its descendants.Uses Logger.metadata/1 underneath.","ref":"Membrane.Pipeline.Action.html#t:log_metadata_t/0","title":"Membrane.Pipeline.Action.log_metadata_t/0","type":"type"},{"doc":"Action that stops, unlinks and removes specified child/children from the pipeline.","ref":"Membrane.Pipeline.Action.html#t:remove_child_t/0","title":"Membrane.Pipeline.Action.remove_child_t/0","type":"type"},{"doc":"Action that instantiates children and links them according to Membrane.ParentSpec.Children's playback state is changed to the current pipeline state. Membrane.Pipeline.handle_spec_started/3 callback is executed once it happens.","ref":"Membrane.Pipeline.Action.html#t:spec_t/0","title":"Membrane.Pipeline.Action.spec_t/0","type":"type"},{"doc":"Starts a timer that will invoke Membrane.Pipeline.handle_tick/3 callback every interval according to the given clock.The timer's id is passed to the Membrane.Pipeline.handle_tick/3 callback and can be used for changing its interval via timer_interval_t/0 or stopping it via stop_timer_t/0.If interval is set to :no_interval, the timer won't issue any ticks until the interval is set with timer_interval_t/0 action.If no clock is passed, pipeline clock is chosen.Timers use Process.send_after/3 under the hood.","ref":"Membrane.Pipeline.Action.html#t:start_timer_t/0","title":"Membrane.Pipeline.Action.start_timer_t/0","type":"type"},{"doc":"Stops a timer started with start_timer_t/0 action.This action is atomic: stopping timer guarantees that no ticks will arrive from it.","ref":"Membrane.Pipeline.Action.html#t:stop_timer_t/0","title":"Membrane.Pipeline.Action.stop_timer_t/0","type":"type"},{"doc":"Type describing actions that can be returned from pipeline callbacks.Returning actions is a way of pipeline interaction with its children and other parts of framework.","ref":"Membrane.Pipeline.Action.html#t:t/0","title":"Membrane.Pipeline.Action.t/0","type":"type"},{"doc":"Changes interval of a timer started with start_timer_t/0.Permitted only from Membrane.Pipeline.handle_tick/3, unless the interval was previously set to :no_interval.If the interval is :no_interval, the timer won't issue any ticks until another t:set_interval_t/0 action. Otherwise, the timer will issue ticks every new interval. The next tick after interval change is scheduled at new_interval + previous_time, where previous_time is the time of the latest tick or the time of returning start_timer_t/0 action if no tick has been sent yet. Note that if current_time - previous_time &gt; new_interval, a burst of div(current_time - previous_time, new_interval) ticks is issued immediately.","ref":"Membrane.Pipeline.Action.html#t:timer_interval_t/0","title":"Membrane.Pipeline.Action.timer_interval_t/0","type":"type"},{"doc":"Structure representing a context that is passed to the callback when pipeline receives a notification.","ref":"Membrane.Pipeline.CallbackContext.Notification.html","title":"Membrane.Pipeline.CallbackContext.Notification","type":"module"},{"doc":"","ref":"Membrane.Pipeline.CallbackContext.Notification.html#t:t/0","title":"Membrane.Pipeline.CallbackContext.Notification.t/0","type":"type"},{"doc":"Structure representing a context that is passed to the callback when pipeline receives an unrecognized message.","ref":"Membrane.Pipeline.CallbackContext.Other.html","title":"Membrane.Pipeline.CallbackContext.Other","type":"module"},{"doc":"","ref":"Membrane.Pipeline.CallbackContext.Other.html#t:t/0","title":"Membrane.Pipeline.CallbackContext.Other.t/0","type":"type"},{"doc":"Structure representing a context that is passed to the callback of the pipeline when it changes its playback state","ref":"Membrane.Pipeline.CallbackContext.PlaybackChange.html","title":"Membrane.Pipeline.CallbackContext.PlaybackChange","type":"module"},{"doc":"","ref":"Membrane.Pipeline.CallbackContext.PlaybackChange.html#t:t/0","title":"Membrane.Pipeline.CallbackContext.PlaybackChange.t/0","type":"type"},{"doc":"Structure representing a context that is passed to the callback of the pipeline when it instantiates children and links them according to Membrane.ParentSpec","ref":"Membrane.Pipeline.CallbackContext.SpecStarted.html","title":"Membrane.Pipeline.CallbackContext.SpecStarted","type":"module"},{"doc":"","ref":"Membrane.Pipeline.CallbackContext.SpecStarted.html#t:t/0","title":"Membrane.Pipeline.CallbackContext.SpecStarted.t/0","type":"type"},{"doc":"Structure representing a context that is passed to the pipeline when handling start and end of stream events.","ref":"Membrane.Pipeline.CallbackContext.StreamManagement.html","title":"Membrane.Pipeline.CallbackContext.StreamManagement","type":"module"},{"doc":"","ref":"Membrane.Pipeline.CallbackContext.StreamManagement.html#t:t/0","title":"Membrane.Pipeline.CallbackContext.StreamManagement.t/0","type":"type"},{"doc":"Structure representing a context that is passed to the callback when pipeline handles timer tick.","ref":"Membrane.Pipeline.CallbackContext.Tick.html","title":"Membrane.Pipeline.CallbackContext.Tick","type":"module"},{"doc":"","ref":"Membrane.Pipeline.CallbackContext.Tick.html#t:t/0","title":"Membrane.Pipeline.CallbackContext.Tick.t/0","type":"type"},{"doc":"Bins, similarly to pipelines, are containers for elements. However, at the same time, they can be placed and linked within pipelines. Although bin is a separate Membrane entity, it can be perceived as a pipeline within an element. Bins can also be nested within one another.There are two main reasons why bins are useful:they enable creating reusable element groupsthey allow managing their children, for instance by dynamically spawning or replacing them as the stream changes.In order to create bin use Membrane.Bin in your callback module.","ref":"Membrane.Bin.html","title":"Membrane.Bin","type":"behaviour"},{"doc":"Brings all the stuff necessary to implement a bin.Options::bring_spec? - if true (default) imports and aliases Membrane.ParentSpec:bring_pad? - if true (default) requires and aliases Membrane.Pad","ref":"Membrane.Bin.html#__using__/1","title":"Membrane.Bin.__using__/1","type":"macro"},{"doc":"Checks whether module is a bin.","ref":"Membrane.Bin.html#bin?/1","title":"Membrane.Bin.bin?/1","type":"function"},{"doc":"Defines that bin exposes a clock which is a proxy to one of its children.If this macro is not called, no ticks will be forwarded to parent, regardless of clock definitions in its children.","ref":"Membrane.Bin.html#def_clock/1","title":"Membrane.Bin.def_clock/1","type":"macro"},{"doc":"Macro that defines input pad for the bin.Allows to use one_of/1 and range/2 functions from Membrane.Caps.Matcher without module prefix.It automatically generates documentation from the given definition and adds compile-time caps specs validation.The type Membrane.Pad.bin_spec_t/0 describes how the definition of pads should look.","ref":"Membrane.Bin.html#def_input_pad/2","title":"Membrane.Bin.def_input_pad/2","type":"macro"},{"doc":"Macro defining options that parametrize bin.It automatically generates appropriate struct and documentation.Options are defined by a keyword list, where each key is an option name and is described by another keyword list with following fields:type: atom, used for parsingspec: typespec for value in struct. If ommitted, for types: [:atom, :boolean, :caps, :keyword, :string, :struct, :time] the default typespec is provided, for others typespec is set to any/0default: default value for option. If not present, value for this option will have to be provided each time options struct is createdinspector: function converting fields' value to a string. Used when creating documentation instead of inspect/1description: string describing an option. It will be used for generating the docs","ref":"Membrane.Bin.html#def_options/1","title":"Membrane.Bin.def_options/1","type":"macro"},{"doc":"Macro that defines output pad for the bin.Allows to use one_of/1 and range/2 functions from Membrane.Caps.Matcher without module prefix.It automatically generates documentation from the given definition and adds compile-time caps specs validation.The type Membrane.Pad.bin_spec_t/0 describes how the definition of pads should look.","ref":"Membrane.Bin.html#def_output_pad/2","title":"Membrane.Bin.def_output_pad/2","type":"macro"},{"doc":"Callback invoked when a child element finishes processing stream via given pad.","ref":"Membrane.Bin.html#c:handle_element_end_of_stream/3","title":"Membrane.Bin.handle_element_end_of_stream/3","type":"callback"},{"doc":"Callback invoked when a child element starts processing stream via given pad.","ref":"Membrane.Bin.html#c:handle_element_start_of_stream/3","title":"Membrane.Bin.handle_element_start_of_stream/3","type":"callback"},{"doc":"Callback invoked on initialization of bin process. It should parse options and initialize bin's internal state. Internally it is invoked inside GenServer.init/1 callback.","ref":"Membrane.Bin.html#c:handle_init/1","title":"Membrane.Bin.handle_init/1","type":"callback"},{"doc":"Callback invoked when a notification comes in from an element.","ref":"Membrane.Bin.html#c:handle_notification/4","title":"Membrane.Bin.handle_notification/4","type":"callback"},{"doc":"Callback invoked when bin receives a message that is not recognized as an internal membrane message.Useful for receiving ticks from timer, data sent from NIFs or other stuff.","ref":"Membrane.Bin.html#c:handle_other/3","title":"Membrane.Bin.handle_other/3","type":"callback"},{"doc":"Callback that is called when new pad has beed added to bin. Executed ONLY for dynamic pads.","ref":"Membrane.Bin.html#c:handle_pad_added/3","title":"Membrane.Bin.handle_pad_added/3","type":"callback"},{"doc":"Callback that is called when some pad of the bin has beed removed. Executed ONLY for dynamic pads.","ref":"Membrane.Bin.html#c:handle_pad_removed/3","title":"Membrane.Bin.handle_pad_removed/3","type":"callback"},{"doc":"Callback invoked when bin transition from :playing to :prepared state has finished, that is all of its children are prepared to be stopped.","ref":"Membrane.Bin.html#c:handle_playing_to_prepared/2","title":"Membrane.Bin.handle_playing_to_prepared/2","type":"callback"},{"doc":"Callback invoked when bin is in :playing state, i.e. all its children are in this state.","ref":"Membrane.Bin.html#c:handle_prepared_to_playing/2","title":"Membrane.Bin.handle_prepared_to_playing/2","type":"callback"},{"doc":"Callback invoked when bin is in :playing state, i.e. all its children are in this state.","ref":"Membrane.Bin.html#c:handle_prepared_to_stopped/2","title":"Membrane.Bin.handle_prepared_to_stopped/2","type":"callback"},{"doc":"Callback invoked when Membrane.ParentSpec is linked and in the same playback state as bin.This callback can be started from handle_init/1 callback or as Membrane.Bin.Action.spec_t/0 action.","ref":"Membrane.Bin.html#c:handle_spec_started/3","title":"Membrane.Bin.handle_spec_started/3","type":"callback"},{"doc":"Callback invoked when bin transition from :stopped to :prepared state has finished, that is all of its children are prepared to enter :playing state.","ref":"Membrane.Bin.html#c:handle_stopped_to_prepared/2","title":"Membrane.Bin.handle_stopped_to_prepared/2","type":"callback"},{"doc":"Callback invoked when bin is in :terminating state, i.e. all its children are in this state.","ref":"Membrane.Bin.html#c:handle_stopped_to_terminating/2","title":"Membrane.Bin.handle_stopped_to_terminating/2","type":"callback"},{"doc":"Callback invoked upon each timer tick. A timer can be started with Membrane.Bin.Action.start_timer_t/0 action.","ref":"Membrane.Bin.html#c:handle_tick/3","title":"Membrane.Bin.handle_tick/3","type":"callback"},{"doc":"Enables to check whether module is membrane bin.","ref":"Membrane.Bin.html#c:membrane_bin?/0","title":"Membrane.Bin.membrane_bin?/0","type":"callback"},{"doc":"Automatically implemented callback used to determine whether bin exports clock.","ref":"Membrane.Bin.html#c:membrane_clock?/0","title":"Membrane.Bin.membrane_clock?/0","type":"callback"},{"doc":"","ref":"Membrane.Bin.html#t:callback_return_t/0","title":"Membrane.Bin.callback_return_t/0","type":"type"},{"doc":"Type that defines a bin name by which it is identified.","ref":"Membrane.Bin.html#t:name_t/0","title":"Membrane.Bin.name_t/0","type":"type"},{"doc":"Defines options that can be passed to start_link/3 and received in handle_init/1 callback.","ref":"Membrane.Bin.html#t:options_t/0","title":"Membrane.Bin.options_t/0","type":"type"},{"doc":"","ref":"Membrane.Bin.html#t:state_t/0","title":"Membrane.Bin.state_t/0","type":"type"},{"doc":"This module contains type specifications of actions that can be returned from bin callbacks.Returning actions is a way of bin interaction with other components and parts of framework. Each action may be returned by any callback unless explicitly stated otherwise.","ref":"Membrane.Bin.Action.html","title":"Membrane.Bin.Action","type":"module"},{"doc":"Action that sends a message to a child identified by name.","ref":"Membrane.Bin.Action.html#t:forward_t/0","title":"Membrane.Bin.Action.forward_t/0","type":"type"},{"doc":"Action that sets Logger metadata for the bin and all its descendants.Uses Logger.metadata/1 underneath.","ref":"Membrane.Bin.Action.html#t:log_metadata_t/0","title":"Membrane.Bin.Action.log_metadata_t/0","type":"type"},{"doc":"Action that stops, unlinks and removes specified child/children from the bin.","ref":"Membrane.Bin.Action.html#t:remove_child_t/0","title":"Membrane.Bin.Action.remove_child_t/0","type":"type"},{"doc":"Action that instantiates children and links them according to Membrane.ParentSpec.Children's playback state is changed to the current bin state. c:Membrane.Parent.handle_spec_started/3 callback is executed once it happens.","ref":"Membrane.Bin.Action.html#t:spec_t/0","title":"Membrane.Bin.Action.spec_t/0","type":"type"},{"doc":"Starts a timer that will invoke Membrane.Bin.handle_tick/3 callback every interval according to the given clock.The timer's id is passed to the Membrane.Bin.handle_tick/3 callback and can be used for changing its interval via timer_interval_t/0 or stopping it via stop_timer_t/0.If interval is set to :no_interval, the timer won't issue any ticks until the interval is set with timer_interval_t/0 action.If no clock is passed, parent clock is chosen.Timers use Process.send_after/3 under the hood.","ref":"Membrane.Bin.Action.html#t:start_timer_t/0","title":"Membrane.Bin.Action.start_timer_t/0","type":"type"},{"doc":"Stops a timer started with start_timer_t/0 action.This action is atomic: stopping timer guarantees that no ticks will arrive from it.","ref":"Membrane.Bin.Action.html#t:stop_timer_t/0","title":"Membrane.Bin.Action.stop_timer_t/0","type":"type"},{"doc":"Type describing actions that can be returned from bin callbacks.Returning actions is a way of bin interaction with its children and other parts of framework.","ref":"Membrane.Bin.Action.html#t:t/0","title":"Membrane.Bin.Action.t/0","type":"type"},{"doc":"Changes interval of a timer started with start_timer_t/0.Permitted only from Membrane.Bin.handle_tick/3, unless the interval was previously set to :no_interval.If the interval is :no_interval, the timer won't issue any ticks until another t:set_interval_t/0 action. Otherwise, the timer will issue ticks every new interval. The next tick after interval change is scheduled at new_interval + previous_time, where previous_time is the time of the latest tick or the time of returning start_timer_t/0 action if no tick has been sent yet. Note that if current_time - previous_time &gt; new_interval, a burst of div(current_time - previous_time, new_interval) ticks is issued immediately.","ref":"Membrane.Bin.Action.html#t:timer_interval_t/0","title":"Membrane.Bin.Action.timer_interval_t/0","type":"type"},{"doc":"Structure representing a context that is passed to the callback when bin receives notification.","ref":"Membrane.Bin.CallbackContext.Notification.html","title":"Membrane.Bin.CallbackContext.Notification","type":"module"},{"doc":"","ref":"Membrane.Bin.CallbackContext.Notification.html#t:t/0","title":"Membrane.Bin.CallbackContext.Notification.t/0","type":"type"},{"doc":"Structure representing a context that is passed to the callback when bin receives unrecognized message.","ref":"Membrane.Bin.CallbackContext.Other.html","title":"Membrane.Bin.CallbackContext.Other","type":"module"},{"doc":"","ref":"Membrane.Bin.CallbackContext.Other.html#t:t/0","title":"Membrane.Bin.CallbackContext.Other.t/0","type":"type"},{"doc":"Structure representing a context that is passed to the bin when when a new dynamic pad instance added is created","ref":"Membrane.Bin.CallbackContext.PadAdded.html","title":"Membrane.Bin.CallbackContext.PadAdded","type":"module"},{"doc":"","ref":"Membrane.Bin.CallbackContext.PadAdded.html#t:t/0","title":"Membrane.Bin.CallbackContext.PadAdded.t/0","type":"type"},{"doc":"Structure representing a context that is passed to the bin when a dynamic pad is removed","ref":"Membrane.Bin.CallbackContext.PadRemoved.html","title":"Membrane.Bin.CallbackContext.PadRemoved","type":"module"},{"doc":"","ref":"Membrane.Bin.CallbackContext.PadRemoved.html#t:t/0","title":"Membrane.Bin.CallbackContext.PadRemoved.t/0","type":"type"},{"doc":"Structure representing a context that is passed to the callback of the bin when it changes playback state","ref":"Membrane.Bin.CallbackContext.PlaybackChange.html","title":"Membrane.Bin.CallbackContext.PlaybackChange","type":"module"},{"doc":"","ref":"Membrane.Bin.CallbackContext.PlaybackChange.html#t:t/0","title":"Membrane.Bin.CallbackContext.PlaybackChange.t/0","type":"type"},{"doc":"Structure representing a context that is passed to the callback of the bin when it instantiates children and links them according to Membrane.ParentSpec","ref":"Membrane.Bin.CallbackContext.SpecStarted.html","title":"Membrane.Bin.CallbackContext.SpecStarted","type":"module"},{"doc":"","ref":"Membrane.Bin.CallbackContext.SpecStarted.html#t:t/0","title":"Membrane.Bin.CallbackContext.SpecStarted.t/0","type":"type"},{"doc":"Structure representing a context that is passed to the bin when handling start and end of stream events.","ref":"Membrane.Bin.CallbackContext.StreamManagement.html","title":"Membrane.Bin.CallbackContext.StreamManagement","type":"module"},{"doc":"","ref":"Membrane.Bin.CallbackContext.StreamManagement.html#t:t/0","title":"Membrane.Bin.CallbackContext.StreamManagement.t/0","type":"type"},{"doc":"Structure representing a context that is passed to the callback when bin handles timer tick.","ref":"Membrane.Bin.CallbackContext.Tick.html","title":"Membrane.Bin.CallbackContext.Tick","type":"module"},{"doc":"","ref":"Membrane.Bin.CallbackContext.Tick.html#t:t/0","title":"Membrane.Bin.CallbackContext.Tick.t/0","type":"type"},{"doc":"Buffer that is attached to the :input pad when working in a :pull mode.It stores Membrane.Buffer, Membrane.Event and Membrane.Caps structs and prevents the situation where the data in a stream contains the discontinuities. It also guarantees that element won't be flooded with the incoming data.","ref":"Membrane.Core.InputBuffer.html","title":"Membrane.Core.InputBuffer","type":"module"},{"doc":"","ref":"Membrane.Core.InputBuffer.html#empty?/1","title":"Membrane.Core.InputBuffer.empty?/1","type":"function"},{"doc":"","ref":"Membrane.Core.InputBuffer.html#enable_toilet/1","title":"Membrane.Core.InputBuffer.enable_toilet/1","type":"function"},{"doc":"","ref":"Membrane.Core.InputBuffer.html#init/5","title":"Membrane.Core.InputBuffer.init/5","type":"function"},{"doc":"","ref":"Membrane.Core.InputBuffer.html#parse_props/1","title":"Membrane.Core.InputBuffer.parse_props/1","type":"function"},{"doc":"","ref":"Membrane.Core.InputBuffer.html#store/3","title":"Membrane.Core.InputBuffer.store/3","type":"function"},{"doc":"","ref":"Membrane.Core.InputBuffer.html#take_and_demand/4","title":"Membrane.Core.InputBuffer.take_and_demand/4","type":"function"},{"doc":"","ref":"Membrane.Core.InputBuffer.html#t:output_t/0","title":"Membrane.Core.InputBuffer.output_t/0","type":"type"},{"doc":"","ref":"Membrane.Core.InputBuffer.html#t:output_value_t/0","title":"Membrane.Core.InputBuffer.output_value_t/0","type":"type"},{"doc":"Properties that can be passed when creating new InputBufferAvailable options are::preffered_size - size which will be the 'target' for InputBuffer - it will make demands trying to grow to this size. Its default value depends on the set Membrane.Buffer.Metric and is obtained via Membrane.Buffer.Metric.input_buf_preferred_size/0:min_demand - the minimal size of a demand that can be sent to the linked output pad. This prevents from excessive message passing between elements. Defaults to a quarter of preferred size.warn_size - in toilet mode (connecting push output to pull input pad), receiving more data than this size triggers a warning. By default it is equal to twice the preffered size.fail_size - in toilet mode (connecting push output to pull input pad), receiving more data than this results in an element failure. By default, it is four times the preffered size.","ref":"Membrane.Core.InputBuffer.html#t:props_t/0","title":"Membrane.Core.InputBuffer.props_t/0","type":"type"},{"doc":"","ref":"Membrane.Core.InputBuffer.html#t:t/0","title":"Membrane.Core.InputBuffer.t/0","type":"type"},{"doc":"Module containing types and functions for operating on elements.For behaviours for elements chceck Membrane.Source, Membrane.Filter and Membrane.Sink.","ref":"Membrane.Element.html","title":"Membrane.Element","type":"module"},{"doc":"Checks whether module is an element.","ref":"Membrane.Element.html#element?/1","title":"Membrane.Element.element?/1","type":"function"},{"doc":"Type that defines an element name by which it is identified.","ref":"Membrane.Element.html#t:name_t/0","title":"Membrane.Element.name_t/0","type":"type"},{"doc":"Defines options that can be received in Membrane.Element.Base.handle_init/1 callback.","ref":"Membrane.Element.html#t:options_t/0","title":"Membrane.Element.options_t/0","type":"type"},{"doc":"Type of user-managed state of element.","ref":"Membrane.Element.html#t:state_t/0","title":"Membrane.Element.state_t/0","type":"type"},{"doc":"Defines possible element types:source, producing buffersfilter, processing bufferssink, consuming buffers","ref":"Membrane.Element.html#t:type_t/0","title":"Membrane.Element.type_t/0","type":"type"},{"doc":"Module defining behaviour for filters - elements processing data.Behaviours for filters are specified, besides this place, in modules Membrane.Element.Base, Membrane.Element.WithOutputPads, and Membrane.Element.WithInputPads.Filters can have both input and output pads. Job of a usual filter is to receive some data on a input pad, process the data and send it through the output pad. If these pads work in pull mode, which is the most common case, then filter is also responsible for receiving demands on the output pad and requesting them on the input pad (for more details, see Membrane.Element.WithOutputPads.handle_demand/5 callback). Filters, like all elements, can of course have multiple pads if needed to provide more complex solutions.","ref":"Membrane.Filter.html","title":"Membrane.Filter","type":"behaviour"},{"doc":"Brings all the stuff necessary to implement a filter element.Options::bring_pad? - if true (default) requires and aliases Membrane.Pad","ref":"Membrane.Filter.html#__using__/1","title":"Membrane.Filter.__using__/1","type":"macro"},{"doc":"Callback that is to process buffers. In contrast to handle_process_list/4, it is passed only a single buffer.Called by default implementation of handle_process_list/4.","ref":"Membrane.Filter.html#c:handle_process/4","title":"Membrane.Filter.handle_process/4","type":"callback"},{"doc":"Callback that is to process buffers.By default calls handle_process/4 for each buffer.For pads in pull mode it is called when buffers have been demanded (by returning :demand action from any callback).For pads in push mode it is invoked when buffers arrive.","ref":"Membrane.Filter.html#c:handle_process_list/4","title":"Membrane.Filter.handle_process_list/4","type":"callback"},{"doc":"Module defining behaviour for sinks - elements consuming data.Behaviours for sinks are specified, besides this place, in modules Membrane.Element.Base, and Membrane.Element.WithInputPads.Sink elements can define only input pads. Job of a usual sink is to receive some data on such pad and consume it (write to a soundcard, send through TCP etc.). If the pad works in pull mode, which is the most common case, then element is also responsible for requesting demands when it is able and willing to consume data (for more details, see Membrane.Element.Action.demand_t/0). Sinks, like all elements, can of course have multiple pads if needed to provide more complex solutions.","ref":"Membrane.Sink.html","title":"Membrane.Sink","type":"behaviour"},{"doc":"Brings all the stuff necessary to implement a sink element.Options::bring_pad? - if true (default) requires and aliases Membrane.Pad","ref":"Membrane.Sink.html#__using__/1","title":"Membrane.Sink.__using__/1","type":"macro"},{"doc":"Callback that is called when buffer should be written by the sink. In contrast to handle_write_list/4, it is passed only a single buffer.Called by default implementation of handle_write_list/4.","ref":"Membrane.Sink.html#c:handle_write/4","title":"Membrane.Sink.handle_write/4","type":"callback"},{"doc":"Callback that is called when buffer should be written by the sink.By default calls handle_write/4 for each buffer.For pads in pull mode it is called when buffers have been demanded (by returning :demand action from any callback).For pads in push mode it is invoked when buffers arrive.","ref":"Membrane.Sink.html#c:handle_write_list/4","title":"Membrane.Sink.handle_write_list/4","type":"callback"},{"doc":"Module that should be used in sources - elements producing data. Declares appropriate behaviours implementation and provides default callbacks implementation.Behaviours for sources are specified in modules Membrane.Element.Base and Membrane.Element.WithOutputPads.Source elements can define only output pads. Job of a usual source is to produce some data (read from soundcard, download through HTTP, etc.) and send it through such pad. If the pad works in pull mode, then element is also responsible for receiving demands and send buffers only if they have previously been demanded (for more details, see Membrane.Element.WithOutputPads.handle_demand/5 callback). Sources, like all elements, can of course have multiple pads if needed to provide more complex solutions.","ref":"Membrane.Source.html","title":"Membrane.Source","type":"module"},{"doc":"Brings all the stuff necessary to implement a source element.Options::bring_pad? - if true (default) requires and aliases Membrane.Pad","ref":"Membrane.Source.html#__using__/1","title":"Membrane.Source.__using__/1","type":"macro"},{"doc":"This module contains type specifications of actions that can be returned from element callbacks.Returning actions is a way of element interaction with other elements and parts of framework. Each action may be returned by any callback (except for Membrane.Element.Base.handle_init/1 and Membrane.Element.Base.handle_shutdown/2, as they do not support returning any actions) unless explicitly stated otherwise.","ref":"Membrane.Element.Action.html","title":"Membrane.Element.Action","type":"module"},{"doc":"Sends buffers through a pad.The pad must have output direction.Allowed only when playback state is playing.","ref":"Membrane.Element.Action.html#t:buffer_t/0","title":"Membrane.Element.Action.buffer_t/0","type":"type"},{"doc":"Sends caps through a pad.The pad must have output direction. Sent caps must fit constraints on the pad.Forbidden when playback state is stopped.","ref":"Membrane.Element.Action.html#t:caps_t/0","title":"Membrane.Element.Action.caps_t/0","type":"type"},{"doc":"","ref":"Membrane.Element.Action.html#t:demand_size_t/0","title":"Membrane.Element.Action.demand_size_t/0","type":"type"},{"doc":"Makes a demand on a pad.The pad must have input direction and work in pull mode. This action does NOT entail sending demand through the pad, but just requesting some amount of data from Membrane.Core.InputBuffer, which sends demands automatically when it runs out of data. If there is any data available at the pad, the data is passed to Membrane.Filter.handle_process_list/4 or Membrane.Sink.handle_write_list/4 callback. Invoked callback is guaranteed not to receive more data than demanded.Demand size can be either a non-negative integer, that overrides existing demand, or a function that is passed current demand, and is to return the new demand.Allowed only when playback state is playing.","ref":"Membrane.Element.Action.html#t:demand_t/0","title":"Membrane.Element.Action.demand_t/0","type":"type"},{"doc":"Marks that processing via a pad (output) has been finished and the pad instance won't be used anymore.Triggers end_of_stream/3 callback at the receiver element. Allowed only when playback is in playing state.","ref":"Membrane.Element.Action.html#t:end_of_stream_t/0","title":"Membrane.Element.Action.end_of_stream_t/0","type":"type"},{"doc":"Sends an event through a pad (input or output).Forbidden when playback state is stopped.","ref":"Membrane.Element.Action.html#t:event_t/0","title":"Membrane.Element.Action.event_t/0","type":"type"},{"doc":"Sends buffers/caps/event to all output pads of element (or to input pads when event occurs on the output pad).Used by default implementations of Membrane.Element.WithInputPads.handle_caps/4 and Membrane.Element.Base.handle_event/4 callbacks in filter.Allowed only when all below conditions are met:element is filter,callback is Membrane.Filter.handle_process_list/4, Membrane.Element.WithInputPads.handle_caps/4 or Membrane.Element.Base.handle_event/4,playback state is valid for sending buffer, caps or event action respectively.Keep in mind that Membrane.Filter.handle_process_list/4 can only forward buffers, Membrane.Element.WithInputPads.handle_caps/4 - caps and Membrane.Element.Base.handle_event/4 - events.","ref":"Membrane.Element.Action.html#t:forward_t/0","title":"Membrane.Element.Action.forward_t/0","type":"type"},{"doc":"This action sets the latency for the element.This action is not premitted in callback Membrane.Element.Base.handle_init/1.","ref":"Membrane.Element.Action.html#t:latency_t/0","title":"Membrane.Element.Action.latency_t/0","type":"type"},{"doc":"Sends a message to the watcher.","ref":"Membrane.Element.Action.html#t:notify_t/0","title":"Membrane.Element.Action.notify_t/0","type":"type"},{"doc":"Suspends/resumes change of playback state.playback_change: :suspend may be returned only from Membrane.Element.Base.handle_stopped_to_prepared/2, Membrane.Element.Base.handle_playing_to_prepared/2, Membrane.Element.Base.handle_prepared_to_playing/2 and Membrane.Element.Base.handle_prepared_to_stopped/2 callbacks, and defers playback state change until playback_change: :resume is returned.playback_change: :resume may be returned from any callback, only when playback state change is suspended, and causes it to finish.There is no straight limit how long playback change can take, but keep in mind that it may affect application quality if not done quick enough.","ref":"Membrane.Element.Action.html#t:playback_change_t/0","title":"Membrane.Element.Action.playback_change_t/0","type":"type"},{"doc":"Executes Membrane.Element.WithOutputPads.handle_demand/5 callback for the given pad if its demand is greater than 0.The pad must have output direction and work in pull mode.Redemand in SourcesIn case of Sources, :redemand is just a helper that simplifies element's code. The element doesn't need to generate the whole demand synchronously at handle_demand or store current demand size in its state, but it can just generate one buffer and return :redemand action. If there is still one or more buffers to produce, returning :redemand triggers the next invocation of handle_demand. In such case, the element is to produce next buffer and call :redemand again. If there are no more buffers demanded, handle_demand is not invoked and the loop ends. One more advantage of the approach with :redemand action is that produced buffers are sent one after another in separate messages and this can possibly improve the latency.Redemand in FiltersRedemand in Filters is useful in a situation where not the entire demand of output pad has been satisfied and there is a need to send a demand for additional buffers through the input pad. A typical example of this situation is a parser that has not demanded enough bytes to parse the whole frame.Usage limitationsAllowed only when playback state is playing.","ref":"Membrane.Element.Action.html#t:redemand_t/0","title":"Membrane.Element.Action.redemand_t/0","type":"type"},{"doc":"Allows to split callback execution into multiple applications of another callback (called from now sub-callback).Executions are synchronous in the element process, and each of them passes subsequent arguments from the args_list, along with the element state (passed as the last argument each time).Return value of each execution of sub-callback can be any valid return value of the original callback (this also means sub-callback can return any action valid for the original callback, unless expliciltly stated). Returned actions are executed immediately (they are NOT accumulated and executed after all sub-callback executions are finished).Useful when a long action is to be undertaken, and partial results need to be returned before entire process finishes (e.g. default implementation of Membrane.Filter.handle_process_list/4 uses split action to invoke Membrane.Filter.handle_process/4 with each buffer)","ref":"Membrane.Element.Action.html#t:split_t/0","title":"Membrane.Element.Action.split_t/0","type":"type"},{"doc":"Starts a timer that will invoke Membrane.Element.Base.handle_tick/3 callback every interval according to the given clock.The timer's id is passed to the Membrane.Element.Base.handle_tick/3 callback and can be used for changing its interval via timer_interval_t/0 or stopping it via stop_timer_t/0.If interval is set to :no_interval, the timer won't issue any ticks until the interval is set with timer_interval_t/0 action.If no clock is passed, parent's clock is chosen.Timers use Process.send_after/3 under the hood.","ref":"Membrane.Element.Action.html#t:start_timer_t/0","title":"Membrane.Element.Action.start_timer_t/0","type":"type"},{"doc":"Stops a timer started with start_timer_t/0 action.This action is atomic: stopping timer guarantees that no ticks will arrive from it.","ref":"Membrane.Element.Action.html#t:stop_timer_t/0","title":"Membrane.Element.Action.stop_timer_t/0","type":"type"},{"doc":"Type that defines a single action that may be returned from element callbacks.Depending on element type, callback, current playback state and other circumstances there may be different actions available.","ref":"Membrane.Element.Action.html#t:t/0","title":"Membrane.Element.Action.t/0","type":"type"},{"doc":"Changes interval of a timer started with start_timer_t/0.Permitted only from Membrane.Element.Base.handle_tick/3, unless the interval was previously set to :no_interval.If the interval is :no_interval, the timer won't issue any ticks until another t:set_interval_t/0 action. Otherwise, the timer will issue ticks every new interval. The next tick after interval change is scheduled at new_interval + previous_time, where previous_time is the time of the latest tick or the time of returning start_timer_t/0 action if no tick has been sent yet. Note that if current_time - previous_time &gt; new_interval, a burst of div(current_time - previous_time, new_interval) ticks is issued immediately.","ref":"Membrane.Element.Action.html#t:timer_interval_t/0","title":"Membrane.Element.Action.timer_interval_t/0","type":"type"},{"doc":"Module defining behaviour common to all elements.When used declares behaviour implementation, provides default callback definitions and imports macros.ElementsElements are units that produce, process or consume data. They can be linked with Membrane.Pipeline, and thus form a pipeline able to perform complex data processing. Each element defines a set of pads, through which it can be linked with other elements. During playback, pads can either send (output pads) or receive (input pads) data. For more information on pads, see Membrane.Pad.To implement an element, one of base modules (Membrane.Source, Membrane.Filter, Membrane.Sink) has to be used, depending on the element type:source, producing buffers (contain only output pads),filter, processing buffers (contain both input and output pads),sink, consuming buffers (contain only input pads). For more information on each element type, check documentation for appropriate base module.BehavioursElement-specific behaviours are specified in modules:Membrane.Element.Base - this module, behaviour common to all elements,Membrane.Element.WithOutputPads - behaviour common to sources and filters,Membrane.Element.WithInputPads - behaviour common to sinks and filters,Base modules (Membrane.Source, Membrane.Filter, Membrane.Sink) - behaviours specific to each element type.CallbacksModules listed above provide specifications of callbacks that define elements lifecycle. All of these callbacks have names with the handle_ prefix. They are used to define reaction to certain events that happen during runtime, and indicate what actions framework should undertake as a result, besides executing element-specific code.For actions that can be returned by each callback, see Membrane.Element.Action module.","ref":"Membrane.Element.Base.html","title":"Membrane.Element.Base","type":"behaviour"},{"doc":"Brings common stuff needed to implement an element. Used by Membrane.Source.__using__/1, Membrane.Filter.__using__/1 and Membrane.Sink.__using__/1.Options::bring_pad? - if true (default) requires and aliases Membrane.Pad","ref":"Membrane.Element.Base.html#__using__/1","title":"Membrane.Element.Base.__using__/1","type":"macro"},{"doc":"Defines that element exports a clock to pipeline.Exporting clock allows pipeline to choose it as the pipeline clock, enabling other elements to synchronize with it. Element's clock is accessible via clock field, while pipeline's one - via parent_clock field in callback contexts. Both of them can be used for starting timers.","ref":"Membrane.Element.Base.html#def_clock/1","title":"Membrane.Element.Base.def_clock/1","type":"macro"},{"doc":"Macro defining options that parametrize element.It automatically generates appropriate struct and documentation.Options are defined by a keyword list, where each key is an option name and is described by another keyword list with following fields:type: atom, used for parsingspec: typespec for value in struct. If ommitted, for types: [:atom, :boolean, :caps, :keyword, :string, :struct, :time] the default typespec is provided, for others typespec is set to any/0default: default value for option. If not present, value for this option will have to be provided each time options struct is createdinspector: function converting fields' value to a string. Used when creating documentation instead of inspect/1description: string describing an option. It will be used for generating the docs","ref":"Membrane.Element.Base.html#def_options/1","title":"Membrane.Element.Base.def_options/1","type":"macro"},{"doc":"Callback that is called when event arrives.Events may arrive from both sinks and sources. In filters by default event is forwarded to all sources or sinks, respectively.","ref":"Membrane.Element.Base.html#c:handle_event/4","title":"Membrane.Element.Base.handle_event/4","type":"callback"},{"doc":"Callback invoked on initialization of element process. It should parse options and initialize element internal state. Internally it is invoked inside GenServer.init/1 callback.","ref":"Membrane.Element.Base.html#c:handle_init/1","title":"Membrane.Element.Base.handle_init/1","type":"callback"},{"doc":"Callback invoked when element receives a message that is not recognized as an internal membrane message.Useful for receiving ticks from timer, data sent from NIFs or other stuff.","ref":"Membrane.Element.Base.html#c:handle_other/3","title":"Membrane.Element.Base.handle_other/3","type":"callback"},{"doc":"Callback that is called when new pad has beed added to element. Executed ONLY for dynamic pads.","ref":"Membrane.Element.Base.html#c:handle_pad_added/3","title":"Membrane.Element.Base.handle_pad_added/3","type":"callback"},{"doc":"Callback that is called when some pad of the element has beed removed. Executed ONLY for dynamic pads.","ref":"Membrane.Element.Base.html#c:handle_pad_removed/3","title":"Membrane.Element.Base.handle_pad_removed/3","type":"callback"},{"doc":"Callback invoked when element goes to :prepared state from state :playing and should get ready to enter :stopped state.All resources allocated in handle_prepared_to_playing/2 callback should be released here, and no more buffers or demands should be sent.","ref":"Membrane.Element.Base.html#c:handle_playing_to_prepared/2","title":"Membrane.Element.Base.handle_playing_to_prepared/2","type":"callback"},{"doc":"Callback invoked when element is supposed to start playing (goes from state :prepared to :playing).This is moment when initial demands are sent and first buffers are generated if there are any pads in the push mode.","ref":"Membrane.Element.Base.html#c:handle_prepared_to_playing/2","title":"Membrane.Element.Base.handle_prepared_to_playing/2","type":"callback"},{"doc":"Callback invoked when element is supposed to stop (goes from state :prepared to :stopped).Usually this is the place for releasing all remaining resources used by the element. For example, if element opens a file in handle_stopped_to_prepared/2, this is the place to close it.","ref":"Membrane.Element.Base.html#c:handle_prepared_to_stopped/2","title":"Membrane.Element.Base.handle_prepared_to_stopped/2","type":"callback"},{"doc":"Callback invoked when element is shutting down just before process is exiting. Internally called in GenServer.terminate/2 callback.","ref":"Membrane.Element.Base.html#c:handle_shutdown/2","title":"Membrane.Element.Base.handle_shutdown/2","type":"callback"},{"doc":"Callback invoked when element goes to :prepared state from state :stopped and should get ready to enter :playing state.Usually most resources used by the element are allocated here. For example, if element opens a file, this is the place to try to actually open it and return error if that has failed. Such resources should be released in handle_prepared_to_stopped/2.","ref":"Membrane.Element.Base.html#c:handle_stopped_to_prepared/2","title":"Membrane.Element.Base.handle_stopped_to_prepared/2","type":"callback"},{"doc":"","ref":"Membrane.Element.Base.html#c:handle_stopped_to_terminating/2","title":"Membrane.Element.Base.handle_stopped_to_terminating/2","type":"callback"},{"doc":"Callback invoked upon each timer tick. A timer can be started with Membrane.Element.Action.start_timer_t action.","ref":"Membrane.Element.Base.html#c:handle_tick/3","title":"Membrane.Element.Base.handle_tick/3","type":"callback"},{"doc":"Automatically implemented callback used to determine whether element exports clock.","ref":"Membrane.Element.Base.html#c:membrane_clock?/0","title":"Membrane.Element.Base.membrane_clock?/0","type":"callback"},{"doc":"Automatically implemented callback used to determine if module is a membrane element.","ref":"Membrane.Element.Base.html#c:membrane_element?/0","title":"Membrane.Element.Base.membrane_element?/0","type":"callback"},{"doc":"Automatically implemented callback determining whether element is a source, a filter or a sink.","ref":"Membrane.Element.Base.html#c:membrane_element_type/0","title":"Membrane.Element.Base.membrane_element_type/0","type":"callback"},{"doc":"Automatically implemented callback returning specification of pads exported by the element.Generated by Membrane.Element.WithInputPads.def_input_pad/2 and Membrane..WithOutputPads.def_output_pad/2 macros.","ref":"Membrane.Element.Base.html#c:membrane_pads/0","title":"Membrane.Element.Base.membrane_pads/0","type":"callback"},{"doc":"Type that defines all valid return values from most callbacks.In case of error, a callback is supposed to return {:error, any} if it is not passed state, and {{:error, any}, state} otherwise.","ref":"Membrane.Element.Base.html#t:callback_return_t/0","title":"Membrane.Element.Base.callback_return_t/0","type":"type"},{"doc":"This module has been deprecated in favour of Membrane.Filter.","ref":"Membrane.Element.Base.Filter.html","title":"Membrane.Element.Base.Filter","type":"module"},{"doc":"This module has been deprecated in favour of Membrane.Sink.","ref":"Membrane.Element.Base.Sink.html","title":"Membrane.Element.Base.Sink","type":"module"},{"doc":"This module has been deprecated in favour of Membrane.Source.","ref":"Membrane.Element.Base.Source.html","title":"Membrane.Element.Base.Source","type":"module"},{"doc":"Module defining behaviour for sink and filter elements.When used declares behaviour implementation, provides default callback definitions and imports macros.For more information on implementing elements, see Membrane.Element.Base.","ref":"Membrane.Element.WithInputPads.html","title":"Membrane.Element.WithInputPads","type":"behaviour"},{"doc":"Macro that defines input pad for the element.Allows to use one_of/1 and range/2 functions from Membrane.Caps.Matcher without module prefix.It automatically generates documentation from the given definition and adds compile-time caps specs validation.The type Membrane.Pad.input_spec_t/0 describes how the definition of pads should look.","ref":"Membrane.Element.WithInputPads.html#def_input_pad/2","title":"Membrane.Element.WithInputPads.def_input_pad/2","type":"macro"},{"doc":"Macro that defines multiple input pads for the element.Deprecated in favor of def_input_pad/2","ref":"Membrane.Element.WithInputPads.html#def_input_pads/1","title":"Membrane.Element.WithInputPads.def_input_pads/1","type":"macro"},{"doc":"Callback invoked when Element is receiving information about new caps for given pad.In filters those caps are forwarded through all output pads by default.","ref":"Membrane.Element.WithInputPads.html#c:handle_caps/4","title":"Membrane.Element.WithInputPads.handle_caps/4","type":"callback"},{"doc":"Callback invoked when the previous element has finished processing via the pad, and it cannot be used anymore.","ref":"Membrane.Element.WithInputPads.html#c:handle_end_of_stream/3","title":"Membrane.Element.WithInputPads.handle_end_of_stream/3","type":"callback"},{"doc":"Callback invoked when element receives Membrane.Event.StartOfStream event.","ref":"Membrane.Element.WithInputPads.html#c:handle_start_of_stream/3","title":"Membrane.Element.WithInputPads.handle_start_of_stream/3","type":"callback"},{"doc":"Module defining behaviour for source and filter elements.When used declares behaviour implementation, provides default callback definitions and imports macros.For more information on implementing elements, see Membrane.Element.Base.","ref":"Membrane.Element.WithOutputPads.html","title":"Membrane.Element.WithOutputPads","type":"behaviour"},{"doc":"Macro that defines output pad for the element.Allows to use one_of/1 and range/2 functions from Membrane.Caps.Matcher without module prefix.It automatically generates documentation from the given definition and adds compile-time caps specs validation.The type Membrane.Pad.output_spec_t/0 describes how the definition of pads should look.","ref":"Membrane.Element.WithOutputPads.html#def_output_pad/2","title":"Membrane.Element.WithOutputPads.def_output_pad/2","type":"macro"},{"doc":"Macro that defines multiple output pads for the element.Deprecated in favor of def_output_pad/2","ref":"Membrane.Element.WithOutputPads.html#def_output_pads/1","title":"Membrane.Element.WithOutputPads.def_output_pads/1","type":"macro"},{"doc":"Callback called when buffers should be emitted by a source or filter.It is called only for output pads in the pull mode, as in their case demand is triggered by the input pad of the subsequent element.In sources, appropriate amount of data should be sent here.In filters, this callback should usually return :demand action with size sufficient for supplying incoming demand. This will result in calling Membrane.Filter.handle_process_list/4, which is to supply the demand.If a source is unable to produce enough buffers, or a filter underestimated returned demand, the :redemand action should be used (see Membrane.Element.Action.redemand_t/0).","ref":"Membrane.Element.WithOutputPads.html#c:handle_demand/5","title":"Membrane.Element.WithOutputPads.handle_demand/5","type":"callback"},{"doc":"Structure representing a context that is passed to the element when receiving information about new caps for given pad.The old_caps field contains caps previously present on the pad, and is equal to pads[pad].caps field.","ref":"Membrane.Element.CallbackContext.Caps.html","title":"Membrane.Element.CallbackContext.Caps","type":"module"},{"doc":"","ref":"Membrane.Element.CallbackContext.Caps.html#t:t/0","title":"Membrane.Element.CallbackContext.Caps.t/0","type":"type"},{"doc":"Structure representing a context that is passed to the element when processing incoming demand.","ref":"Membrane.Element.CallbackContext.Demand.html","title":"Membrane.Element.CallbackContext.Demand","type":"module"},{"doc":"","ref":"Membrane.Element.CallbackContext.Demand.html#t:t/0","title":"Membrane.Element.CallbackContext.Demand.t/0","type":"type"},{"doc":"Structure representing a context that is passed to the element when handling event.","ref":"Membrane.Element.CallbackContext.Event.html","title":"Membrane.Element.CallbackContext.Event","type":"module"},{"doc":"","ref":"Membrane.Element.CallbackContext.Event.html#t:t/0","title":"Membrane.Element.CallbackContext.Event.t/0","type":"type"},{"doc":"Structure representing a context that is passed to the callback when element receives unrecognized message.","ref":"Membrane.Element.CallbackContext.Other.html","title":"Membrane.Element.CallbackContext.Other","type":"module"},{"doc":"","ref":"Membrane.Element.CallbackContext.Other.html#t:t/0","title":"Membrane.Element.CallbackContext.Other.t/0","type":"type"},{"doc":"Structure representing a context that is passed to the element when a new dynamic pad instance is created","ref":"Membrane.Element.CallbackContext.PadAdded.html","title":"Membrane.Element.CallbackContext.PadAdded","type":"module"},{"doc":"","ref":"Membrane.Element.CallbackContext.PadAdded.html#t:t/0","title":"Membrane.Element.CallbackContext.PadAdded.t/0","type":"type"},{"doc":"Structure representing a context that is passed to the element when a dynamic pad is removed","ref":"Membrane.Element.CallbackContext.PadRemoved.html","title":"Membrane.Element.CallbackContext.PadRemoved","type":"module"},{"doc":"","ref":"Membrane.Element.CallbackContext.PadRemoved.html#t:t/0","title":"Membrane.Element.CallbackContext.PadRemoved.t/0","type":"type"},{"doc":"Structure representing a context that is passed to the callback of the element when it changes playback state","ref":"Membrane.Element.CallbackContext.PlaybackChange.html","title":"Membrane.Element.CallbackContext.PlaybackChange","type":"module"},{"doc":"","ref":"Membrane.Element.CallbackContext.PlaybackChange.html#t:t/0","title":"Membrane.Element.CallbackContext.PlaybackChange.t/0","type":"type"},{"doc":"Structure representing a context that is passed to the element when new buffer arrives.","ref":"Membrane.Element.CallbackContext.Process.html","title":"Membrane.Element.CallbackContext.Process","type":"module"},{"doc":"","ref":"Membrane.Element.CallbackContext.Process.html#t:t/0","title":"Membrane.Element.CallbackContext.Process.t/0","type":"type"},{"doc":"Structure representing a context that is passed to the element when handling start and end of stream events.","ref":"Membrane.Element.CallbackContext.StreamManagement.html","title":"Membrane.Element.CallbackContext.StreamManagement","type":"module"},{"doc":"","ref":"Membrane.Element.CallbackContext.StreamManagement.html#t:t/0","title":"Membrane.Element.CallbackContext.StreamManagement.t/0","type":"type"},{"doc":"Structure representing a context that is passed to the callback when element handles timer tick.","ref":"Membrane.Element.CallbackContext.Tick.html","title":"Membrane.Element.CallbackContext.Tick","type":"module"},{"doc":"","ref":"Membrane.Element.CallbackContext.Tick.html#t:t/0","title":"Membrane.Element.CallbackContext.Tick.t/0","type":"type"},{"doc":"Structure representing a context that is passed to the element when new buffer arrives to the sink.","ref":"Membrane.Element.CallbackContext.Write.html","title":"Membrane.Element.CallbackContext.Write","type":"module"},{"doc":"","ref":"Membrane.Element.CallbackContext.Write.html#t:t/0","title":"Membrane.Element.CallbackContext.Write.t/0","type":"type"},{"doc":"Structure representing topology of a pipeline/bin.It can be incorporated into a pipeline or a bin by returning Membrane.Pipeline.Action.spec_t/0 or Membrane.Bin.Action.spec_t/0 action, respectively. This commonly happens within Membrane.Pipeline.handle_init/1 and Membrane.Bin.handle_init/1, but can be done in any other callback also.ChildrenChildren that should be spawned when the pipeline/bin starts can be defined with the :children field. You have to set it to a map, where keys are valid children names (Membrane.Child.name_t/0) that are unique within this pipeline/bin and values are either child's module or struct of that module.Sample definitions:%{ first_element: %Element.With.Options.Struct{option_a: 42}, some_element: Element.Without.Options, some_bin: Bin.Using.Default.Options }LinksLinks that should be made when the children are spawned can be defined with the :links field. Links can be defined with use of link/1 and to/2 functions that allow to specify elements linked, and via_in/2 and via_out/2 that allow to specify pads' names and parameters. If pads are not specified, name :input is assumed for inputs and :output for outputs.Sample definition:[ link(:source_a) |&gt; to(:converter) |&gt; via_in(:input_a, buffer: [preferred_size: 20_000]) |&gt; to(:mixer), link(:source_b) |&gt; via_out(:custom_output) |&gt; via_in(:input_b, pad: [mute: true]) |&gt; to(:mixer) |&gt; via_in(:input, [warn_size: 264_000, fail_size: 300_000]) |&gt; to(:sink) ]BinsFor bins boundaries there are special links allowed. User should define links between bin's input and first child's input (input-input type) and last child's output and bin output (output-output type). In this case, link_bin_input/2 and to_bin_output/3 should be used.Sample definition:[ link_bin_input() |&gt; to(:filter1) |&gt; to(:filter2) |&gt; to_bin_output(:custom_output) ]Dynamic padsIn most cases dynamic pads can be linked the same way as static ones, although in the following situations exact pad reference must be passed instead of a name:When that reference is needed later, for example to handle a notification related to that particular pad instancepad = Pad.ref(:output, make_ref()) [ link(:tee) |&gt; via_out(pad) |&gt; to(:sink) ]When linking dynamic pads of a bin with its children, for example in Membrane.Bin.handle_pad_added/3@impl true def handle_pad_added(Pad.ref(:input, _) = pad, _ctx, state) do links = [link_bin_input(pad) |&gt; to(:mixer)] {{:ok, spec: %ParentSpec{links: links}}, state} endStream sync:stream_sync field can be used for specifying elements that should start playing at the same moment. An example can be audio and video player sinks. This option accepts either :sinks atom or list of groups (lists) of elements. Passing :sinks results in synchronizing all sinks in the pipeline, while passing list of groups of elements synchronizes all elements in each group. It is worth mentioning that to keep the stream synchronized all involved elements need to rely on the same clock.By default, no elements are synchronized.Sample definitions: %ParentSpec{stream_sync: [[:element1, :element2], [:element3, :element4]]} %ParentSpec{stream_sync: :sinks}Clock providerClock provider is an element that exports clock that should be used as the pipeline clock. The pipeline clock is the default clock used by elements' timers. For more information see Membrane.Element.Base.def_clock/1.","ref":"Membrane.ParentSpec.html","title":"Membrane.ParentSpec","type":"module"},{"doc":"Begins a link.See the links section of the moduledoc for more information.","ref":"Membrane.ParentSpec.html#link/1","title":"Membrane.ParentSpec.link/1","type":"function"},{"doc":"Begins a link with a bin's pad.See the links section of the moduledoc for more information.","ref":"Membrane.ParentSpec.html#link_bin_input/2","title":"Membrane.ParentSpec.link_bin_input/2","type":"function"},{"doc":"Continues or ends a link.See the links section of the moduledoc for more information.","ref":"Membrane.ParentSpec.html#to/2","title":"Membrane.ParentSpec.to/2","type":"function"},{"doc":"Ends a link with a bin's output.See the links section of the moduledoc for more information.","ref":"Membrane.ParentSpec.html#to_bin_output/3","title":"Membrane.ParentSpec.to_bin_output/3","type":"function"},{"doc":"Specifies input pad name and properties of the subsequent child.See the links section of the moduledoc for more information.","ref":"Membrane.ParentSpec.html#via_in/3","title":"Membrane.ParentSpec.via_in/3","type":"function"},{"doc":"Specifies output pad name and properties of the preceding child.See the links section of the moduledoc for more information.","ref":"Membrane.ParentSpec.html#via_out/3","title":"Membrane.ParentSpec.via_out/3","type":"function"},{"doc":"","ref":"Membrane.ParentSpec.html#t:child_spec_t/0","title":"Membrane.ParentSpec.child_spec_t/0","type":"type"},{"doc":"","ref":"Membrane.ParentSpec.html#t:children_spec_t/0","title":"Membrane.ParentSpec.children_spec_t/0","type":"type"},{"doc":"","ref":"Membrane.ParentSpec.html#t:links_spec_t/0","title":"Membrane.ParentSpec.links_spec_t/0","type":"type"},{"doc":"Options passed to the child when linking its pad with a different one.The allowed options are::buffer - keyword allowing to configure Membrane.Core.InputBuffer between elements. Valid only for input pads. See Membrane.Core.InputBuffer.props_t/0 for configurable properties.:options - any child-specific options that will be available in Membrane.Pad.Data struct.","ref":"Membrane.ParentSpec.html#t:pad_props_t/0","title":"Membrane.ParentSpec.pad_props_t/0","type":"type"},{"doc":"Struct used when starting and linking children within a pipeline or a bin.","ref":"Membrane.ParentSpec.html#t:t/0","title":"Membrane.ParentSpec.t/0","type":"type"},{"doc":"Module that keeps track of types used by both elements and bins","ref":"Membrane.Child.html","title":"Membrane.Child","type":"module"},{"doc":"","ref":"Membrane.Child.html#t:name_t/0","title":"Membrane.Child.name_t/0","type":"type"},{"doc":"","ref":"Membrane.Child.html#t:options_t/0","title":"Membrane.Child.options_t/0","type":"type"},{"doc":"Struct describing child entry of a parent.The public fields are:name - child namemodule - child moduleoptions - options passed to the childcomponent_type - either :element or :binOther fields in the struct ARE NOT PART OF THE PUBLIC API and should not be accessed or relied on.","ref":"Membrane.ChildEntry.html","title":"Membrane.ChildEntry","type":"module"},{"doc":"","ref":"Membrane.ChildEntry.html#t:t/0","title":"Membrane.ChildEntry.t/0","type":"type"},{"doc":"Structure representing a single chunk of data that flows between elements.For now, it is just a wrapper around bitstring with optionally some metadata attached to it, but in future releases we plan to support different payload types.","ref":"Membrane.Buffer.html","title":"Membrane.Buffer","type":"module"},{"doc":"","ref":"Membrane.Buffer.html#t:metadata_t/0","title":"Membrane.Buffer.metadata_t/0","type":"type"},{"doc":"","ref":"Membrane.Buffer.html#t:t/0","title":"Membrane.Buffer.t/0","type":"type"},{"doc":"Describes capabilities of some pad.Every pad has some capabilities, which define a type of data that pad is expecting. This format can be, for example, raw audio with specific sample rate or encoded audio in given format.To link two pads together, their capabilities have to be compatible.","ref":"Membrane.Caps.html","title":"Membrane.Caps","type":"module"},{"doc":"","ref":"Membrane.Caps.html#t:t/0","title":"Membrane.Caps.t/0","type":"type"},{"doc":"Event is an entity that can be sent between elements.Events can flow either downstream or upstream - they can be sent with Membrane.Element.Action.event_t/0, and can be handled in Membrane.Element.Base.handle_event/4. Each event is to implement Membrane.EventProtocol, which allows to configure its behaviour.","ref":"Membrane.Event.html","title":"Membrane.Event","type":"module"},{"doc":"See Membrane.EventProtocol.async?/1.","ref":"Membrane.Event.html#async?/1","title":"Membrane.Event.async?/1","type":"function"},{"doc":"","ref":"Membrane.Event.html#event?/1","title":"Membrane.Event.event?/1","type":"function"},{"doc":"See Membrane.EventProtocol.sticky?/1.","ref":"Membrane.Event.html#sticky?/1","title":"Membrane.Event.sticky?/1","type":"function"},{"doc":"","ref":"Membrane.Event.html#t:t/0","title":"Membrane.Event.t/0","type":"type"},{"doc":"Protocol that allows to configure behaviour of Membrane.Events.Each event has to implement or derive this protocol.","ref":"Membrane.EventProtocol.html","title":"Membrane.EventProtocol","type":"protocol"},{"doc":"Determines whether event is synchronized with buffers (sync) or not (async). Defaults to false (sync).Buffers and sync events are always received in the same order they are sent. Async events are handled before any enqueued buffers that are waiting to be processed (e.g. in Membrane.InputBuffer).","ref":"Membrane.EventProtocol.html#async?/1","title":"Membrane.EventProtocol.async?/1","type":"function"},{"doc":"Specifies whether event is sent right away (not sticky), or it is 'pushed' by the next sent buffer (sticky). Defaults to false (not sticky).Returning a sticky event from a callback stores it in a queue. When the next buffer is to be sent, all events from the queue are sent before it. An example can be the Membrane.Event.StartOfStream event.","ref":"Membrane.EventProtocol.html#sticky?/1","title":"Membrane.EventProtocol.sticky?/1","type":"function"},{"doc":"","ref":"Membrane.EventProtocol.html#t:t/0","title":"Membrane.EventProtocol.t/0","type":"type"},{"doc":"A notification is a message sent from Membrane.Element to a parent via action Membrane.Element.Action.notify_t/0 returned from any callback.A notification can be handled in parent with c:Membrane.Parent.handle_notification/4 callback.","ref":"Membrane.Notification.html","title":"Membrane.Notification","type":"module"},{"doc":"","ref":"Membrane.Notification.html#t:t/0","title":"Membrane.Notification.t/0","type":"type"},{"doc":"Pads are units defined by elements and bins, allowing them to be linked with their siblings. This module consists of pads typespecs and utils.Each pad is described by its name, direction, availability, mode and possible caps. For pads to be linkable, these properties have to be compatible. For more information on each of them, check appropriate type in this module.Each link can only consist of exactly two pads.","ref":"Membrane.Pad.html","title":"Membrane.Pad","type":"module"},{"doc":"","ref":"Membrane.Pad.html#assert_public_name!/1","title":"Membrane.Pad.assert_public_name!/1","type":"function"},{"doc":"Returns pad availability mode for given availability.","ref":"Membrane.Pad.html#availability_mode/1","title":"Membrane.Pad.availability_mode/1","type":"function"},{"doc":"","ref":"Membrane.Pad.html#create_private_name/1","title":"Membrane.Pad.create_private_name/1","type":"function"},{"doc":"","ref":"Membrane.Pad.html#get_corresponding_bin_pad/1","title":"Membrane.Pad.get_corresponding_bin_pad/1","type":"function"},{"doc":"","ref":"Membrane.Pad.html#is_availability/1","title":"Membrane.Pad.is_availability/1","type":"macro"},{"doc":"","ref":"Membrane.Pad.html#is_availability_dynamic/1","title":"Membrane.Pad.is_availability_dynamic/1","type":"macro"},{"doc":"","ref":"Membrane.Pad.html#is_availability_static/1","title":"Membrane.Pad.is_availability_static/1","type":"macro"},{"doc":"","ref":"Membrane.Pad.html#is_pad_name/1","title":"Membrane.Pad.is_pad_name/1","type":"macro"},{"doc":"","ref":"Membrane.Pad.html#is_pad_ref/1","title":"Membrane.Pad.is_pad_ref/1","type":"macro"},{"doc":"","ref":"Membrane.Pad.html#is_public_name/1","title":"Membrane.Pad.is_public_name/1","type":"macro"},{"doc":"Returns the name for the given pad reference","ref":"Membrane.Pad.html#name_by_ref/1","title":"Membrane.Pad.name_by_ref/1","type":"function"},{"doc":"","ref":"Membrane.Pad.html#opposite_direction/1","title":"Membrane.Pad.opposite_direction/1","type":"function"},{"doc":"Creates a static pad reference.","ref":"Membrane.Pad.html#ref/1","title":"Membrane.Pad.ref/1","type":"macro"},{"doc":"Creates a dynamic pad reference.","ref":"Membrane.Pad.html#ref/2","title":"Membrane.Pad.ref/2","type":"macro"},{"doc":"Type describing availability mode of a created pad::static - there always exist exactly one instance of such pad.:dynamic - multiple instances of such pad may be created and removed (which entails executing handle_pad_added and handle_pad_removed callbacks, respectively).","ref":"Membrane.Pad.html#t:availability_mode_t/0","title":"Membrane.Pad.availability_mode_t/0","type":"type"},{"doc":"Values used when defining pad availability::always - a static pad, which can remain unlinked in stopped state only.:on_request - a dynamic pad, instance of which is created every time it is linked to another pad. Thus linking the pad with k other pads, creates k instances of the pad, and links each with another pad.","ref":"Membrane.Pad.html#t:availability_t/0","title":"Membrane.Pad.availability_t/0","type":"type"},{"doc":"For bins there are exactly the same options for both directions. Demand unit is derived from the first element inside the bin linked to the given input.","ref":"Membrane.Pad.html#t:bin_spec_t/0","title":"Membrane.Pad.bin_spec_t/0","type":"type"},{"doc":"Pad options used in spec_t/0","ref":"Membrane.Pad.html#t:common_spec_options_t/0","title":"Membrane.Pad.common_spec_options_t/0","type":"type"},{"doc":"Type describing a pad. Contains data parsed from spec_t/0","ref":"Membrane.Pad.html#t:description_t/0","title":"Membrane.Pad.description_t/0","type":"type"},{"doc":"Defines possible pad directions::output - data can only be sent through such pad,:input - data can only be received through such pad.One cannot link two pads with the same direction.","ref":"Membrane.Pad.html#t:direction_t/0","title":"Membrane.Pad.direction_t/0","type":"type"},{"doc":"Possible id of dynamic pad","ref":"Membrane.Pad.html#t:dynamic_id_t/0","title":"Membrane.Pad.dynamic_id_t/0","type":"type"},{"doc":"Describes how an input pad should be declared inside an element.","ref":"Membrane.Pad.html#t:input_spec_t/0","title":"Membrane.Pad.input_spec_t/0","type":"type"},{"doc":"Describes how an element sends and receives data. Modes are strictly related to pad directions::push output pad - element can send data through such pad whenever it wants.:push input pad - element has to deal with data whenever it comes through such pad, and do it fast enough not to let data accumulate on such pad, what may lead to overflow of element process erlang queue, which is highly unwanted.:pull output pad - element can send data through such pad only if it have already received demand on the pad. Sending small, limited amount of undemanded data is supported and handled by Membrane.Core.InputBuffer.:pull input pad - element receives through such pad only data that it has previously demanded, so that no undemanded data can arrive.Linking pads with different modes is possible, but only in case of output pad working in push mode, and input in pull mode. Moreover, toilet mode of Membrane.Core.InputBuffer has to be enabled then.For more information on transfering data and demands, see Membrane.Source, Membrane.Filter, Membrane.Sink.","ref":"Membrane.Pad.html#t:mode_t/0","title":"Membrane.Pad.mode_t/0","type":"type"},{"doc":"Defines the name of pad or group of dynamic pads","ref":"Membrane.Pad.html#t:name_t/0","title":"Membrane.Pad.name_t/0","type":"type"},{"doc":"Describes how an output pad should be declared inside an element.","ref":"Membrane.Pad.html#t:output_spec_t/0","title":"Membrane.Pad.output_spec_t/0","type":"type"},{"doc":"Defines the term by which the pad instance is identified.","ref":"Membrane.Pad.html#t:ref_t/0","title":"Membrane.Pad.ref_t/0","type":"type"},{"doc":"Describes how a pad should be declared in element or bin.","ref":"Membrane.Pad.html#t:spec_t/0","title":"Membrane.Pad.spec_t/0","type":"type"},{"doc":"Struct describing current pad state.The public fields are::accepted_caps - specification of possible caps that are accepted on the pad. See Membrane.Caps.Matcher for more information. This field only applies to elements' pads.:availability - see Membrane.Pad.availability_t:caps - the most recent Membrane.Caps that have been sent (output) or received (input) on the pad. May be nil if not yet set. This field only applies to elements' pads.:demand - current demand requested on the pad working in pull mode. This field only applies to elements' pads.:direction - see Membrane.Pad.direction_t:end_of_stream? - flag determining whether the stream processing via the pad has been finished:mode - see Membrane.Pad.mode_t. This field only applies to elements' pads.:name - see Membrane.Pad.name_t. Do not mistake with :ref:options - options passed in Membrane.ParentSpec when linking pad:ref - see Membrane.Pad.ref_t:start_of_stream? - flag determining whether the stream processing via the pad has been startedOther fields in the struct ARE NOT PART OF THE PUBLIC API and should not be accessed or relied on.","ref":"Membrane.Pad.Data.html","title":"Membrane.Pad.Data","type":"module"},{"doc":"","ref":"Membrane.Pad.Data.html#t:t/0","title":"Membrane.Pad.Data.t/0","type":"type"},{"doc":"This protocol describes actions common to all payload types.The most basic payload type is simply a binary for which Elixir.Membrane.Payload is implemented by the Membrane Core.","ref":"Membrane.Payload.html","title":"Membrane.Payload","type":"protocol"},{"doc":"Concatenates the contents of two payloads.","ref":"Membrane.Payload.html#concat/2","title":"Membrane.Payload.concat/2","type":"function"},{"doc":"Drops first n bytes of payload.","ref":"Membrane.Payload.html#drop/2","title":"Membrane.Payload.drop/2","type":"function"},{"doc":"Returns a module responsible for this type of payload and implementing Membrane.Payload.Behaviour","ref":"Membrane.Payload.html#module/1","title":"Membrane.Payload.module/1","type":"function"},{"doc":"Returns total size of payload in bytes","ref":"Membrane.Payload.html#size/1","title":"Membrane.Payload.size/1","type":"function"},{"doc":"Splits the payload at given position (1st part has the size equal to at_pos argument)at_pos has to be greater than 0 and smaller than the size of payload, otherwise an error is raised. This guarantees returned payloads are never empty.","ref":"Membrane.Payload.html#split_at/2","title":"Membrane.Payload.split_at/2","type":"function"},{"doc":"Converts payload into binary","ref":"Membrane.Payload.html#to_binary/1","title":"Membrane.Payload.to_binary/1","type":"function"},{"doc":"","ref":"Membrane.Payload.html#t:t/0","title":"Membrane.Payload.t/0","type":"type"},{"doc":"Specifies API for metrics that analyze data in terms of a given unit","ref":"Membrane.Buffer.Metric.html","title":"Membrane.Buffer.Metric","type":"behaviour"},{"doc":"","ref":"Membrane.Buffer.Metric.html#c:buffers_size/1","title":"Membrane.Buffer.Metric.buffers_size/1","type":"callback"},{"doc":"","ref":"Membrane.Buffer.Metric.html#from_unit/1","title":"Membrane.Buffer.Metric.from_unit/1","type":"function"},{"doc":"","ref":"Membrane.Buffer.Metric.html#c:input_buf_preferred_size/0","title":"Membrane.Buffer.Metric.input_buf_preferred_size/0","type":"callback"},{"doc":"","ref":"Membrane.Buffer.Metric.html#c:split_buffers/2","title":"Membrane.Buffer.Metric.split_buffers/2","type":"callback"},{"doc":"","ref":"Membrane.Buffer.Metric.html#t:unit_t/0","title":"Membrane.Buffer.Metric.unit_t/0","type":"type"},{"doc":"Implementation of Membrane.Buffer.Metric for the :bytes unit","ref":"Membrane.Buffer.Metric.ByteSize.html","title":"Membrane.Buffer.Metric.ByteSize","type":"module"},{"doc":"Implementation of Membrane.Buffer.Metric for the :buffers unit","ref":"Membrane.Buffer.Metric.Count.html","title":"Membrane.Buffer.Metric.Count","type":"module"},{"doc":"Module that allows to specify valid caps and verify that they match specification.Caps specifications (specs) should be in one of the formats:simply module name of the desired caps (e.g. Membrane.Caps.Audio.Raw or Raw with proper alias)tuple with module name and keyword list of specs for specific caps fields (e.g. {Raw, format: :s24le})list of the formats described aboveField values can be specified in following ways:By a raw value for the field (e.g. :s24le)Using range/2 for values comparable with Kernel.&lt;=/2 and Kernel.&gt;=/2 (e.g. Matcher.range(0, 255))With one_of/1 and a list of valid values (e.g Matcher.one_of([:u8, :s16le, :s32le])) Checks on the values from list are performed recursively i.e. it can contain another range/2, for example Matcher.one_of([0, Matcher.range(2, 4), Matcher.range(10, 20)])If the specs are defined inside of Membrane.Element.WithInputPads.def_input_pad/2 and Membrane.Element.WithOutputPads.def_output_pad/2 module name can be omitted from range/2 and one_of/1 calls.ExampleBelow is a pad definition with an example of specs for caps matcher:alias Membrane.Caps.Video.Raw def_input_pad :input, demand_unit: :buffers, caps: {Raw, format: one_of([:I420, :I422]), aligned: true}","ref":"Membrane.Caps.Matcher.html","title":"Membrane.Caps.Matcher","type":"module"},{"doc":"Function determining whether the caps match provided specs.When :any is used as specs, caps can by anything (i.e. they can be invalid)","ref":"Membrane.Caps.Matcher.html#match?/2","title":"Membrane.Caps.Matcher.match?/2","type":"function"},{"doc":"Returns opaque specification of list of valid values for caps field.","ref":"Membrane.Caps.Matcher.html#one_of/1","title":"Membrane.Caps.Matcher.one_of/1","type":"function"},{"doc":"Returns opaque specification of range of valid values for caps field.","ref":"Membrane.Caps.Matcher.html#range/2","title":"Membrane.Caps.Matcher.range/2","type":"function"},{"doc":"Function used to make sure caps specs are valid.In particular, valid caps:Have shape described by caps_specs_t/0 typeIf they contain keyword list, the keys are present in requested caps typeIt returns :ok when caps are valid and {:error, reason} otherwise","ref":"Membrane.Caps.Matcher.html#validate_specs/1","title":"Membrane.Caps.Matcher.validate_specs/1","type":"function"},{"doc":"","ref":"Membrane.Caps.Matcher.html#t:caps_spec_t/0","title":"Membrane.Caps.Matcher.caps_spec_t/0","type":"type"},{"doc":"","ref":"Membrane.Caps.Matcher.html#t:caps_specs_t/0","title":"Membrane.Caps.Matcher.caps_specs_t/0","type":"type"},{"doc":"","ref":"Membrane.Caps.Matcher.html#t:one_of_t/0","title":"Membrane.Caps.Matcher.one_of_t/0","type":"opaque"},{"doc":"","ref":"Membrane.Caps.Matcher.html#t:range_t/0","title":"Membrane.Caps.Matcher.range_t/0","type":"opaque"},{"doc":"Generic discontinuity event.This event means that flow of buffers in the stream was interrupted, but stream itself is not done.Frequent reasons for this are soundcards' drops while capturing sound, network data loss etc.If duration of the discontinuity is known, it can be passed as an argument.","ref":"Membrane.Event.Discontinuity.html","title":"Membrane.Event.Discontinuity","type":"module"},{"doc":"","ref":"Membrane.Event.Discontinuity.html#t:duration_t/0","title":"Membrane.Event.Discontinuity.duration_t/0","type":"type"},{"doc":"","ref":"Membrane.Event.Discontinuity.html#t:t/0","title":"Membrane.Event.Discontinuity.t/0","type":"type"},{"doc":"Generic underrun event.This event means that certain element is willing to consume more buffers, but there are none available.It makes sense to use this event as an upstream event to notify previous elements in the pipeline that they should generate more buffers.","ref":"Membrane.Event.Underrun.html","title":"Membrane.Event.Underrun","type":"module"},{"doc":"","ref":"Membrane.Event.Underrun.html#t:t/0","title":"Membrane.Event.Underrun.t/0","type":"type"},{"doc":"Default implementation of Membrane.EventProtocol.If used in defimpl, not implemented callbacks fallback to default ones.","ref":"Membrane.EventProtocol.DefaultImpl.html","title":"Membrane.EventProtocol.DefaultImpl","type":"module"},{"doc":"Behaviour that should be implemented by every module that has Membrane.Payload protocol implementation.","ref":"Membrane.Payload.Behaviour.html","title":"Membrane.Payload.Behaviour","type":"behaviour"},{"doc":"Creates an empty payload","ref":"Membrane.Payload.Behaviour.html#c:empty/0","title":"Membrane.Payload.Behaviour.empty/0","type":"callback"},{"doc":"Creates a new payload initialized with the given binary","ref":"Membrane.Payload.Behaviour.html#c:new/1","title":"Membrane.Payload.Behaviour.new/1","type":"callback"},{"doc":"Membrane.Payload.Behaviour implementation for binary payload. Complements Membrane.Payload protocol implementation.","ref":"Membrane.Payload.Binary.html","title":"Membrane.Payload.Binary","type":"module"},{"doc":"Wrapper around the Elixir logger. Adds Membrane prefixes and handles verbose logging.PrefixesBy default, this wrapper prepends each log with a prefix containing the context of the log, such as element name. This can be turned off via configuration:use Mix.Config config :membrane_core, :logger, prefix: falseRegardless of the config, the prefix is passed to Logger metadata under :mb_prefix key. Prefixes are passed via process dictionary, so they have process-wide scope, but it can be extended with get_prefix/0 and set_prefix/1.Verbose loggingFor verbose debug logs that should be silenced by default, use debug_verbose/2 macro. Verbose logs are purged in the compile time, unless turned on via configuration:use Mix.Config config :membrane_core, :logger, verbose: trueVerbose debugs should be used for logs that are USUALLY USEFUL for debugging, but printed so often that they make the output illegible. For example, it may be a good idea to debug_verbose from within Membrane.Filter.handle_process/4 or Membrane.Element.WithOutputPads.handle_demand/5 callbacks.","ref":"Membrane.Logger.html","title":"Membrane.Logger","type":"module"},{"doc":"Wrapper around Logger.bare_log/3 that adds Membrane prefix.For details, see the 'prefixes' section of the moduledoc.","ref":"Membrane.Logger.html#bare_log/3","title":"Membrane.Logger.bare_log/3","type":"function"},{"doc":"Wrapper around Logger.debug/2 that adds Membrane prefix.For details, see the 'prefixes' section of the moduledoc.","ref":"Membrane.Logger.html#debug/2","title":"Membrane.Logger.debug/2","type":"macro"},{"doc":"Macro for verbose debug logs, that are silenced by default.For details, see the 'verbose logging' section of the moduledoc.","ref":"Membrane.Logger.html#debug_verbose/2","title":"Membrane.Logger.debug_verbose/2","type":"macro"},{"doc":"Wrapper around Logger.error/2 that adds Membrane prefix.For details, see the 'prefixes' section of the moduledoc.","ref":"Membrane.Logger.html#error/2","title":"Membrane.Logger.error/2","type":"macro"},{"doc":"Returns the Membrane logger config.","ref":"Membrane.Logger.html#get_config/0","title":"Membrane.Logger.get_config/0","type":"function"},{"doc":"Returns value at given key in the Membrane logger config.","ref":"Membrane.Logger.html#get_config/2","title":"Membrane.Logger.get_config/2","type":"function"},{"doc":"Returns the logger prefix.Returns an empty string if no prefix is set.","ref":"Membrane.Logger.html#get_prefix/0","title":"Membrane.Logger.get_prefix/0","type":"function"},{"doc":"Wrapper around Logger.info/2 that adds Membrane prefix.For details, see the 'prefixes' section of the moduledoc.","ref":"Membrane.Logger.html#info/2","title":"Membrane.Logger.info/2","type":"macro"},{"doc":"Wrapper around Logger.log/3 that adds Membrane prefix.For details, see the 'prefixes' section of the moduledoc.","ref":"Membrane.Logger.html#log/3","title":"Membrane.Logger.log/3","type":"macro"},{"doc":"Sets the logger prefix. Avoid using in Membrane-managed processes.This function is intended to enable setting prefix obtained in a Membrane-managed process via get_prefix/1. If some custom data needs to be prepended to logs, please use Logger.metadata/1.Prefixes in Membrane-managed processes are set automatically and using this function there would overwrite them, which is usually unintended.","ref":"Membrane.Logger.html#set_prefix/1","title":"Membrane.Logger.set_prefix/1","type":"function"},{"doc":"Wrapper around Logger.warn/2 that adds Membrane prefix.For details, see the 'prefixes' section of the moduledoc.","ref":"Membrane.Logger.html#warn/2","title":"Membrane.Logger.warn/2","type":"macro"},{"doc":"This module contains a set of assertion functions and macros.These assertions will work ONLY in conjunction with Membrane.Testing.Pipeline and ONLY when pid of tested pipeline is provided as an argument to these assertions.","ref":"Membrane.Testing.Assertions.html","title":"Membrane.Testing.Assertions","type":"module"},{"doc":"Asserts that Membrane.Testing.Pipeline received or is going to receive end_of_stream notification about from the element with a name element_name within the timeout period specified in milliseconds.assert_end_of_stream(pipeline, :an_element)","ref":"Membrane.Testing.Assertions.html#assert_end_of_stream/4","title":"Membrane.Testing.Assertions.assert_end_of_stream/4","type":"macro"},{"doc":"Asserts that pipeline received or will receive a notification from the element with name element_name within the timeout period specified in milliseconds.The notification_pattern must be a match pattern.assert_pipeline_notified(pipeline, :element_name, :hi)","ref":"Membrane.Testing.Assertions.html#assert_pipeline_notified/4","title":"Membrane.Testing.Assertions.assert_pipeline_notified/4","type":"macro"},{"doc":"Asserts that pipeline's playback state (see Membrane.PlaybackState) changed or will change from previous_state to current_state within the timeout period specified in milliseconds.The prev_state and current_state must be match patterns.Assertion can be either made by providing state before and after the change as atoms: assert_pipeline_playback_changed(pipeline, :prepared, :playing)Or by using an _ to assert on change from any state to other: assert_pipeline_playback_changed(pipeline, _, :playing)","ref":"Membrane.Testing.Assertions.html#assert_pipeline_playback_changed/4","title":"Membrane.Testing.Assertions.assert_pipeline_playback_changed/4","type":"macro"},{"doc":"Asserts that pipeline received or will receive a message matching message_pattern from another process within the timeout period specified in milliseconds.The message_pattern must be a match pattern.assert_pipeline_receive(pid, :tick)Such call would flunk if the message :tick has not been handled by c:Membrane.Parent.handle_other/3 within the timeout.","ref":"Membrane.Testing.Assertions.html#assert_pipeline_receive/3","title":"Membrane.Testing.Assertions.assert_pipeline_receive/3","type":"macro"},{"doc":"Asserts that Membrane.Testing.Sink with name sink_name received or will receive a buffer matching pattern within the timeout period specified in milliseconds.When the Membrane.Testing.Sink is a part of Membrane.Testing.Pipeline you can assert whether it received a buffer matching provided pattern.{:ok, pid} = Membrane.Testing.Pipeline.start_link(%Membrane.Testing.Pipeline.Options{ elements: [ ...., the_sink: %Membrane.Testing.Sink{} ] })You can match for exact value:assert_sink_buffer(pid, :the_sink ,%Membrane.Buffer{payload: ^specific_payload})You can also use pattern to extract data from the buffer:assert_sink_buffer(pid, :sink, %Buffer{payload: &lt;&lt;data::16&gt;&gt; &lt;&gt; &lt;&lt;255&gt;&gt;}) do_something(data)","ref":"Membrane.Testing.Assertions.html#assert_sink_buffer/4","title":"Membrane.Testing.Assertions.assert_sink_buffer/4","type":"macro"},{"doc":"Asserts that Membrane.Testing.Sink with name sink_name received or will receive caps matching pattern within the timeout period specified in milliseconds.When the Membrane.Testing.Sink is a part of Membrane.Testing.Pipeline you can assert whether it received caps matching provided pattern.{:ok, pid} = Membrane.Testing.Pipeline.start_link(%Membrane.Testing.Pipeline.Options{ elements: [ ...., the_sink: %Membrane.Testing.Sink{} ] })You can match for exact value:assert_sink_caps(pid, :the_sink , %Caps{prop: ^value})You can also use pattern to extract data from the caps:assert_sink_caps(pid, :the_sink , %Caps{prop: value}) do_something(value)","ref":"Membrane.Testing.Assertions.html#assert_sink_caps/4","title":"Membrane.Testing.Assertions.assert_sink_caps/4","type":"macro"},{"doc":"Asserts that Membrane.Testing.Sink with name sink_name received or will receive an event within the timeout period specified in milliseconds.When a Membrane.Testing.Sink is part of Membrane.Testing.Pipeline you can assert whether it received an event matching a provided pattern.assert_sink_event(pid, :the_sink, %Discontinuity{})","ref":"Membrane.Testing.Assertions.html#assert_sink_event/4","title":"Membrane.Testing.Assertions.assert_sink_event/4","type":"macro"},{"doc":"Asserts that Membrane.Testing.Pipeline received or is going to receive start_of_stream notification from the element with a name element_name within the timeout period specified in milliseconds.assert_start_of_stream(pipeline, :an_element)","ref":"Membrane.Testing.Assertions.html#assert_start_of_stream/4","title":"Membrane.Testing.Assertions.assert_start_of_stream/4","type":"macro"},{"doc":"Refutes that pipeline received or will receive a notification from the element with name element_name within the timeout period specified in milliseconds.The notification_pattern must be a match pattern.refute_pipeline_notified(pipeline, :element_name, :hi)","ref":"Membrane.Testing.Assertions.html#refute_pipeline_notified/4","title":"Membrane.Testing.Assertions.refute_pipeline_notified/4","type":"macro"},{"doc":"Asserts that pipeline has not received and will not receive a message from another process matching message_pattern within the timeout period specified in milliseconds.The message_pattern must be a match pattern.refute_pipeline_receive(pid, :tick)Such call would flunk if the message :tick has been handled by c:Membrane.Parent.handle_other/3.","ref":"Membrane.Testing.Assertions.html#refute_pipeline_receive/3","title":"Membrane.Testing.Assertions.refute_pipeline_receive/3","type":"macro"},{"doc":"Asserts that Membrane.Testing.Sink with name sink_name has not received and will not receive a buffer matching buffer_pattern within the timeout period specified in milliseconds.Similarly as in the assert_sink_buffer/4 the_sink needs to be part of a Membrane.Testing.Pipeline.refute_sink_buffer(pipeline, :the_sink, %Buffer{payload: &lt;&lt;0xA1, 0xB2&gt;&gt;})Such expression will flunk if the_sink received or will receive a buffer with payload &lt;&lt;0xA1, 0xB2&gt;&gt;.","ref":"Membrane.Testing.Assertions.html#refute_sink_buffer/4","title":"Membrane.Testing.Assertions.refute_sink_buffer/4","type":"macro"},{"doc":"Asserts that Membrane.Testing.Sink with name sink_name has not received and will not receive caps matching caps_pattern within the timeout period specified in milliseconds.Similarly as in the assert_sink_caps/4 the_sink needs to be part of a Membrane.Testing.Pipeline.refute_sink_caps(pipeline, :the_sink, %Caps{prop: ^val})Such expression will flunk if the_sink received or will receive caps with property equal to value of val variable.","ref":"Membrane.Testing.Assertions.html#refute_sink_caps/4","title":"Membrane.Testing.Assertions.refute_sink_caps/4","type":"macro"},{"doc":"Asserts that Membrane.Testing.Sink has not received and will not receive event matching provided pattern within the timeout period specified in milliseconds.refute_sink_event(pid, :the_sink, %Discontinuity{})","ref":"Membrane.Testing.Assertions.html#refute_sink_event/4","title":"Membrane.Testing.Assertions.refute_sink_event/4","type":"macro"},{"doc":"Empty event that can be used in tests","ref":"Membrane.Testing.Event.html","title":"Membrane.Testing.Event","type":"module"},{"doc":"This Pipeline was created to reduce testing boilerplate and ease communication with its elements. It also provides a utility for informing testing process about playback state changes and received notifications.When you want a build Pipeline to test your elements you need three things:Pipeline ModuleList of elementsLinks between those elementsWhen creating pipelines for tests the only essential part is the list of elements. In most cases during the tests, elements are linked in a way that :output pad is linked to :input pad of subsequent element. So we only need to pass a list of elements and links can be generated automatically.To start a testing pipeline you need to build Membrane.Testing.Pipeline.Options struct and pass to Membrane.Testing.Pipeline.start_link/2. Links are generated by populate_links/1.options = %Membrane.Testing.Pipeline.Options { elements: [ el1: MembraneElement1, el2: MembraneElement2, ... ] } {:ok, pipeline} = Membrane.Testing.Pipeline.start_link(options)If you need to pass custom links, you can always do it using :links field of Membrane.Testing.Pipeline.Options struct.options = %Membrane.Testing.Pipeline.Options { elements: [ el1: MembraneElement1, el2: MembraneElement2, ], links: [ link(:el1) |&gt; to(:el2) ] }You can also pass a custom pipeline module, by using :module field of Membrane.Testing.Pipeline.Options struct. Every callback of the module will be executed before the callbacks of Testing.Pipeline. Passed module has to return a proper spec. There should be no elements nor links specified in options passed to test pipeline as that would result in a failure.options = %Membrane.Testing.Pipeline.Options { module: Your.Module }See Membrane.Testing.Pipeline.Options for available options.AssertionsThis pipeline is designed to work with Membrane.Testing.Assertions. Check them out or see example below for more details.Messaging childrenYou can send messages to children using their names specified in the elements list. Please check message_child/3 for more details.Example usageFirstly, we can start the pipeline providing its options:options = %Membrane.Testing.Pipeline.Options { elements: [ source: %Membrane.Testing.Source{}, tested_element: TestedElement, sink: %Membrane.Testing.Sink{} ] } {:ok, pipeline} = Membrane.Testing.Pipeline.start_link(options)We can now wait till the end of the stream reaches the sink element (don't forget to import Membrane.Testing.Assertions):assert_end_of_stream(pipeline, :sink)We can also assert that the Membrane.Testing.Sink processed a specific buffer:assert_sink_buffer(pipeline, :sink, %Membrane.Buffer{payload: 1})","ref":"Membrane.Testing.Pipeline.html","title":"Membrane.Testing.Pipeline","type":"module"},{"doc":"Sends message to a child by Element name.ExampleKnowing that pipeline has child named sink, message can be sent as follows:message_child(pipeline, :sink, {:message, &quot;to handle&quot;})","ref":"Membrane.Testing.Pipeline.html#message_child/3","title":"Membrane.Testing.Pipeline.message_child/3","type":"function"},{"doc":"Changes playback state of pipeline to :playing.","ref":"Membrane.Testing.Pipeline.html#play/1","title":"Membrane.Testing.Pipeline.play/1","type":"function"},{"doc":"Links subsequent elements using default pads (linking :input to :output of previous element).ExamplePipeline.populate_links([el1: MembraneElement1, el2: MembraneElement2])","ref":"Membrane.Testing.Pipeline.html#populate_links/1","title":"Membrane.Testing.Pipeline.populate_links/1","type":"function"},{"doc":"Changes playback state to :prepared.","ref":"Membrane.Testing.Pipeline.html#prepare/1","title":"Membrane.Testing.Pipeline.prepare/1","type":"function"},{"doc":"","ref":"Membrane.Testing.Pipeline.html#start/2","title":"Membrane.Testing.Pipeline.start/2","type":"function"},{"doc":"","ref":"Membrane.Testing.Pipeline.html#start_link/2","title":"Membrane.Testing.Pipeline.start_link/2","type":"function"},{"doc":"Changes playback state to :stopped.","ref":"Membrane.Testing.Pipeline.html#stop/1","title":"Membrane.Testing.Pipeline.stop/1","type":"function"},{"doc":"Changes pipeline's playback state to :stopped and terminates its process.","ref":"Membrane.Testing.Pipeline.html#stop_and_terminate/2","title":"Membrane.Testing.Pipeline.stop_and_terminate/2","type":"function"},{"doc":"Structure representing options passed to testing pipeline.Test Processpid of process that shall receive messages when Pipeline invokes playback state change callback and receives notification.ElementsList of element specs.LinksList describing the links between elements.ModulePipeline Module with custom callbacks.Custom ArgsArguments for Module's handle_init callback.If links are not present or set to nil they will be populated automatically based on elements order using default pad names.","ref":"Membrane.Testing.Pipeline.Options.html","title":"Membrane.Testing.Pipeline.Options","type":"module"},{"doc":"","ref":"Membrane.Testing.Pipeline.Options.html#t:t/0","title":"Membrane.Testing.Pipeline.Options.t/0","type":"type"},{"doc":"Structure representing state.Test Processpid of process that shall receive messages when Pipeline invokes playback state change callback and receives notification.ModulePipeline Module with custom callbacks.Custom Pipeline StateState of the pipeline defined by Module.","ref":"Membrane.Testing.Pipeline.State.html","title":"Membrane.Testing.Pipeline.State","type":"module"},{"doc":"","ref":"Membrane.Testing.Pipeline.State.html#t:t/0","title":"Membrane.Testing.Pipeline.State.t/0","type":"type"},{"doc":"Sink Element that notifies the pipeline about buffers and events it receives.By default Sink will demand buffers automatically, but you can override that behaviour by using autodemand option. If set to false no automatic demands shall be made. Demands can be then triggered by sending {:make_demand, size} message.This element can be used in conjunction with Membrane.Testing.Pipeline to enable asserting on buffers and events it receives.alias Membrane.Testing {:ok, pid} = Testing.Pipeline.start_link(Testing.Pipeline.Options{ elements: [ ..., sink: %Testing.Sink{} ] })Asserting that Membrane.Testing.Sink element processed a buffer that matches a specific pattern can be achieved using Membrane.Testing.Assertions.assert_sink_buffer/3.assert_sink_buffer(pid, :sink ,%Membrane.Buffer{payload: 255})Element optionsPassed via struct Membrane.Testing.Sink.t/0autodemand booleanDefault value: trueIf true element will automatically make demands. If it is set to false demand has to be triggered manually by sending :make_demand message.Pads:inputAvailability:alwaysCaps:anyDemand unit:buffersDirection:inputMode:pullName:input","ref":"Membrane.Testing.Sink.html","title":"Membrane.Testing.Sink","type":"module"},{"doc":"Returns pads descriptions for Membrane.Testing.Sink","ref":"Membrane.Testing.Sink.html#membrane_pads/0","title":"Membrane.Testing.Sink.membrane_pads/0","type":"function"},{"doc":"Returns description of options available for this module","ref":"Membrane.Testing.Sink.html#options/0","title":"Membrane.Testing.Sink.options/0","type":"function"},{"doc":"Struct containing options for Membrane.Testing.Sink","ref":"Membrane.Testing.Sink.html#t:t/0","title":"Membrane.Testing.Sink.t/0","type":"type"},{"doc":"Testing Element for supplying data based on generator function or payloads passed through options.Example usageAs mentioned earlier you can use this element in one of two ways, providing either a generator function or an Enumerable.t.If you provide an Enumerable.t with payloads, then each of those payloads will be wrapped in a Membrane.Buffer and sent through :output pad.%Source{output: [0xA1, 0xB2, 0xC3, 0xD4]}In order to specify Membrane.Testing.Source with generator function you need to provide initial state and function that matches generator/0 type. This function should take state and demand size as its arguments and return a tuple consisting of actions that element will return during the Membrane.Element.WithOutputPads.handle_demand/5 callback and new state.generator_function = fn state, size -&gt; #generate some buffers {actions, state + 1} end %Source{output: {1, generator_function}}Element optionsPassed via struct Membrane.Testing.Source.t/0output {initial_state :: any(), generator} | Enum.t()Default value: {0, &amp;Membrane.Testing.Source.default_buf_gen/2}If output is an enumerable with Membrane.Payload.t() then buffer containing those payloads will be sent through the :output pad and followed by Membrane.Element.Action.end_of_stream_t/0. If output is a {initial_state, function} tuple then the the function will be invoked each time handle_demand is called. It is an action generator that takes two arguments. The first argument is the state that is initially set to initial_state. The second one defines the size of the demand. Such function should return {actions, next_state} where actions is a list of actions that will be returned from handle_demand/4 and next_state is the value that will be used for the next call.Pads:outputAvailability:alwaysCaps:anyDirection:outputMode:pullName:output","ref":"Membrane.Testing.Source.html","title":"Membrane.Testing.Source","type":"module"},{"doc":"","ref":"Membrane.Testing.Source.html#default_buf_gen/2","title":"Membrane.Testing.Source.default_buf_gen/2","type":"function"},{"doc":"Returns pads descriptions for Membrane.Testing.Source","ref":"Membrane.Testing.Source.html#membrane_pads/0","title":"Membrane.Testing.Source.membrane_pads/0","type":"function"},{"doc":"Returns description of options available for this module","ref":"Membrane.Testing.Source.html#options/0","title":"Membrane.Testing.Source.options/0","type":"function"},{"doc":"Creates output with generator function from list of buffers.","ref":"Membrane.Testing.Source.html#output_from_buffers/1","title":"Membrane.Testing.Source.output_from_buffers/1","type":"function"},{"doc":"","ref":"Membrane.Testing.Source.html#t:generator/0","title":"Membrane.Testing.Source.generator/0","type":"type"},{"doc":"Struct containing options for Membrane.Testing.Source","ref":"Membrane.Testing.Source.html#t:t/0","title":"Membrane.Testing.Source.t/0","type":"type"},{"doc":"Clock is a Membrane utility that allows elements to measure time according to a particular clock, which can be e.g. a soundcard hardware clock.Internally, Clock is a GenServer process that can receive updates (see update_message_t/0), which are messages containing amount of time until the next update. For example, a sink playing audio to the sound card can send an update before each write to the sound card buffer (for practical reasons that can be done every 100 or 1000 writes). Although it might be more intuitive to send updates with the time passed, in practice the described approach turns out to be more convenient, as it simplifies the first update.Basing on updates, Clock calculates the ratio_t/0 of its time to the reference time. The reference time can be configured with :time_provider option. The ratio is broadcasted (see ratio_message_t/0) to subscribers (see subscribe/2)processes willing to synchronize to the custom clock. Subscribers can adjust their timers according to received ratio - timers started with Membrane.Element.Action.start_timer_t/0 action in elements do it automatically. Initial ratio is equal to 1, which means that if no updates are received, Clock is synchronized to the reference time.Proxy modeClock can work in proxy mode, which means it cannot receive updates, but it receives ratio from another clock instead, and forwards it to subscribers. Proxy mode is enabled with proxy_for: pid or proxy: true (no initial proxy) option, and the proxy is set/changed using proxy_for/2.","ref":"Membrane.Clock.html","title":"Membrane.Clock","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Membrane.Clock.html#child_spec/1","title":"Membrane.Clock.child_spec/1","type":"function"},{"doc":"Sets a new proxy clock to clock_to_proxy_for.","ref":"Membrane.Clock.html#proxy_for/2","title":"Membrane.Clock.proxy_for/2","type":"function"},{"doc":"","ref":"Membrane.Clock.html#start/2","title":"Membrane.Clock.start/2","type":"function"},{"doc":"","ref":"Membrane.Clock.html#start_link/2","title":"Membrane.Clock.start_link/2","type":"function"},{"doc":"Subscribes pid for receiving ratio_message_t/0 messages from the clock.This function can be called multiple times from the same process. To unsubscribe, unsubscribe/2 should be called the same amount of times. The subscribed pid always receives one message, regardless of how many times it called subscribe/2.","ref":"Membrane.Clock.html#subscribe/2","title":"Membrane.Clock.subscribe/2","type":"function"},{"doc":"Unsubscribes pid from receiving ratio_message_t/0 messages from the clock.For unsubscription to take effect, unsubscribe/2 should be called the same amount of times as subscribe/2.","ref":"Membrane.Clock.html#unsubscribe/2","title":"Membrane.Clock.unsubscribe/2","type":"function"},{"doc":"Options accepted by start_link/2 and start/2 functions.They are the following:time_provider - function providing the reference time in millisecondsproxy - determines whether the Clock should work in proxy modeproxy_for - enables the proxy mode and sets proxied Clock to pidCheck the moduledoc for more details.","ref":"Membrane.Clock.html#t:option_t/0","title":"Membrane.Clock.option_t/0","type":"type"},{"doc":"Ratio message sent by the Clock to all its subscribers. It contains the ratio of the custom clock time to the reference time.","ref":"Membrane.Clock.html#t:ratio_message_t/0","title":"Membrane.Clock.ratio_message_t/0","type":"type"},{"doc":"Ratio of the Clock time to the reference time.","ref":"Membrane.Clock.html#t:ratio_t/0","title":"Membrane.Clock.ratio_t/0","type":"type"},{"doc":"","ref":"Membrane.Clock.html#t:t/0","title":"Membrane.Clock.t/0","type":"type"},{"doc":"Update message received by the Clock. It should contain the time till the next update.","ref":"Membrane.Clock.html#t:update_message_t/0","title":"Membrane.Clock.update_message_t/0","type":"type"},{"doc":"Traces element's path inside a pipeline. Path is a list consisted of following pipeline/bin/element names down the assembled pipeline. Information is being stored in a process dictionary and can be set/appended to.","ref":"Membrane.ComponentPath.html","title":"Membrane.ComponentPath","type":"module"},{"doc":"Appends given name to the current path.If path has not been previously set then creates new one with given name.","ref":"Membrane.ComponentPath.html#append/1","title":"Membrane.ComponentPath.append/1","type":"function"},{"doc":"Returns formatted string of given path's names joined with separator.","ref":"Membrane.ComponentPath.html#format/2","title":"Membrane.ComponentPath.format/2","type":"function"},{"doc":"Returns currently stored path.If path has not been set, empty list is returned.","ref":"Membrane.ComponentPath.html#get/0","title":"Membrane.ComponentPath.get/0","type":"function"},{"doc":"Works the same as format/2 but uses currently stored path","ref":"Membrane.ComponentPath.html#get_formatted/1","title":"Membrane.ComponentPath.get_formatted/1","type":"function"},{"doc":"Sets current path.If path had already existed then replaces it.","ref":"Membrane.ComponentPath.html#set/1","title":"Membrane.ComponentPath.set/1","type":"function"},{"doc":"Convenient combination of set/1 and append/1.","ref":"Membrane.ComponentPath.html#set_and_append/2","title":"Membrane.ComponentPath.set_and_append/2","type":"function"},{"doc":"","ref":"Membrane.ComponentPath.html#t:path_t/0","title":"Membrane.ComponentPath.path_t/0","type":"type"},{"doc":"Playback states describe the state of an element or a pipeline. There are following playback states::stopped - Idle. No resources should be initialized nor allocated.:prepared - Ready for processing data. All necessary resources should be allocated and initialized.:playing - Data is being processed.Every playback state change is done step-by-step meaning that when going from :stopped to :playing there are 2 state changes (:stopped -&gt; :prepared and :prepared -&gt; :playing) resulting in invocation of proper callbacks (such as Membrane.Element.Base.handle_stopped_to_prepared/2 or c:Membrane.Parent.handle_prepared_to_playing/2)","ref":"Membrane.PlaybackState.html","title":"Membrane.PlaybackState","type":"module"},{"doc":"","ref":"Membrane.PlaybackState.html#is_playback_state/1","title":"Membrane.PlaybackState.is_playback_state/1","type":"macro"},{"doc":"","ref":"Membrane.PlaybackState.html#t:t/0","title":"Membrane.PlaybackState.t/0","type":"type"},{"doc":"Sync allows to synchronize multiple processes, so that they could perform their jobs at the same time.The main purpose for Sync is to synchronize multiple streams within a pipeline. The flow of usage goes as follows:A Sync process is started.Processes register themselves (or are registered) in the Sync, using register/2. Registered processes are not being synchronized till the Sync becomes active (see the next step). Each registered process is monitored and automatically unregistered upon exit. Sync can be setup to exit when all the registered processes exit by passing the empty_exit? option to start_link/2.When all processes that need to be registered are registered, the Sync can be activated with activate/1 function. This disables registration and enables synchronization.Once a process needs to sync, it invokes sync/2, which results in blocking until all the registered processes invoke sync/2. This works only when the Sync is active - otherwise calling sync/2 returns immediately.Once all the ready processes invoke sync/2, the calls return, and they become registered again.When synchronization needs to be turned off, the Sync should be deactivated with deactivate/2. This disables synchronization and enables registration again. All the calls to sync/2 return immediately.If a process designed to work with Sync should not be synced, no_sync/0 should be used. Then all calls to sync/2 return immediately.","ref":"Membrane.Sync.html","title":"Membrane.Sync","type":"module"},{"doc":"","ref":"Membrane.Sync.html#activate/1","title":"Membrane.Sync.activate/1","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Membrane.Sync.html#child_spec/1","title":"Membrane.Sync.child_spec/1","type":"function"},{"doc":"","ref":"Membrane.Sync.html#deactivate/1","title":"Membrane.Sync.deactivate/1","type":"function"},{"doc":"Returns a Sync that always returns immediately when calling sync/2 on it.","ref":"Membrane.Sync.html#no_sync/0","title":"Membrane.Sync.no_sync/0","type":"function"},{"doc":"","ref":"Membrane.Sync.html#register/2","title":"Membrane.Sync.register/2","type":"function"},{"doc":"Starts a Sync process linked to the current process.Options:empty_exit? - if true, Sync automatically exits when all the registered processes exit; defaults to false","ref":"Membrane.Sync.html#start_link/2","title":"Membrane.Sync.start_link/2","type":"function"},{"doc":"","ref":"Membrane.Sync.html#sync/2","title":"Membrane.Sync.sync/2","type":"function"},{"doc":"","ref":"Membrane.Sync.html#t:status_t/0","title":"Membrane.Sync.status_t/0","type":"type"},{"doc":"","ref":"Membrane.Sync.html#t:t/0","title":"Membrane.Sync.t/0","type":"type"},{"doc":"Defines basic telemetry event types used by Membrane's Core. Membrane uses Telemetry Package for instrumentation and does not store or save any measurements by itself.It is user's responsibility to use some sort of metrics reporter that will be attached to :telemetry package to consume and process generated measurements.InstrumentationMembrane.Telemetry publishes functions that return described below event names.The following events are published by Membrane's Core with following measurement types and metadata:[:membrane, :input_buffer, :size] - used by Membrane.Core.InputBuffer to report current buffer's size inside functions Membrane.Core.InputBuffer.store/3 and Membrane.Core.InputBuffer.take_and_demand/4.Measurement: input_buffer_size_event_value_t/0Metadata: %{}[:membrane, :link, :new] - used by Membrane.Core.Parent.ChildLifeController.LinkHandler to report new link connection being initialized in pipeline.Measurement: new_link_event_value_t/0Metadata: %{}","ref":"Membrane.Telemetry.html","title":"Membrane.Telemetry","type":"module"},{"doc":"","ref":"Membrane.Telemetry.html#input_buffer_size_event_name/0","title":"Membrane.Telemetry.input_buffer_size_event_name/0","type":"function"},{"doc":"","ref":"Membrane.Telemetry.html#new_link_event_name/0","title":"Membrane.Telemetry.new_link_event_name/0","type":"function"},{"doc":"","ref":"Membrane.Telemetry.html#t:event_name_t/0","title":"Membrane.Telemetry.event_name_t/0","type":"type"},{"doc":"element_path - element's process path with pad's name that input buffer is attached tomethod - input buffer's function call namevalue - current buffer's size","ref":"Membrane.Telemetry.html#t:input_buffer_size_event_value_t/0","title":"Membrane.Telemetry.input_buffer_size_event_value_t/0","type":"type"},{"doc":"parent_path - process path of link's parentfrom - from element nameto - to element namepad_from - from's pad namepad_to - to's pad name","ref":"Membrane.Telemetry.html#t:new_link_event_value_t/0","title":"Membrane.Telemetry.new_link_event_value_t/0","type":"type"},{"doc":"Module containing functions needed to perform handling of time.Membrane always internally uses nanosecond as a time unit. This is how all time units should represented in the code unless there's a good reason to act differently.Please note that Erlang VM may internally use different units and that may differ from platform to platform. Still, unless you need to perform calculations that do not touch hardware clock, you should use Membrane units for consistency.","ref":"Membrane.Time.html","title":"Membrane.Time","type":"module"},{"doc":"Returns time in days, represented as a rational number.","ref":"Membrane.Time.html#as_days/1","title":"Membrane.Time.as_days/1","type":"function"},{"doc":"Returns time in hours, represented as a rational number.","ref":"Membrane.Time.html#as_hours/1","title":"Membrane.Time.as_hours/1","type":"function"},{"doc":"Returns time in microseconds, represented as a rational number.","ref":"Membrane.Time.html#as_microseconds/1","title":"Membrane.Time.as_microseconds/1","type":"function"},{"doc":"Returns time in milliseconds, represented as a rational number.","ref":"Membrane.Time.html#as_milliseconds/1","title":"Membrane.Time.as_milliseconds/1","type":"function"},{"doc":"Returns time in minutes, represented as a rational number.","ref":"Membrane.Time.html#as_minutes/1","title":"Membrane.Time.as_minutes/1","type":"function"},{"doc":"Returns time in nanoseconds, represented as a rational number.","ref":"Membrane.Time.html#as_nanoseconds/1","title":"Membrane.Time.as_nanoseconds/1","type":"function"},{"doc":"Returns time in seconds, represented as a rational number.","ref":"Membrane.Time.html#as_seconds/1","title":"Membrane.Time.as_seconds/1","type":"function"},{"doc":"Returns one day in Membrane.Time units.","ref":"Membrane.Time.html#day/0","title":"Membrane.Time.day/0","type":"function"},{"doc":"","ref":"Membrane.Time.html#day/1","title":"Membrane.Time.day/1","type":"function"},{"doc":"Returns given amount of days in Membrane.Time units.","ref":"Membrane.Time.html#days/1","title":"Membrane.Time.days/1","type":"function"},{"doc":"Converts DateTime to Membrane.Time units.","ref":"Membrane.Time.html#from_datetime/1","title":"Membrane.Time.from_datetime/1","type":"function"},{"doc":"Converts iso8601 string to Membrane.Time units. If value is invalid, throws match error.","ref":"Membrane.Time.html#from_iso8601!/1","title":"Membrane.Time.from_iso8601!/1","type":"function"},{"doc":"Converts NTP timestamp (time since 0h on 1st Jan 1900) into Unix timestamp (time since 1st Jan 1970) represented in Membrane.Time units.NTP timestamp uses fixed point representation with the integer part in the first 32 bits and the fractional part in the last 32 bits.","ref":"Membrane.Time.html#from_ntp_timestamp/1","title":"Membrane.Time.from_ntp_timestamp/1","type":"function"},{"doc":"Returns one hour in Membrane.Time units.","ref":"Membrane.Time.html#hour/0","title":"Membrane.Time.hour/0","type":"function"},{"doc":"","ref":"Membrane.Time.html#hour/1","title":"Membrane.Time.hour/1","type":"function"},{"doc":"Returns given amount of hours in Membrane.Time units.","ref":"Membrane.Time.html#hours/1","title":"Membrane.Time.hours/1","type":"function"},{"doc":"","ref":"Membrane.Time.html#is_t/1","title":"Membrane.Time.is_t/1","type":"macro"},{"doc":"Checks whether a value is Membrane.Time.t.","ref":"Membrane.Time.html#is_time/1","title":"Membrane.Time.is_time/1","type":"macro"},{"doc":"Returns one microsecond in Membrane.Time units.","ref":"Membrane.Time.html#microsecond/0","title":"Membrane.Time.microsecond/0","type":"function"},{"doc":"","ref":"Membrane.Time.html#microsecond/1","title":"Membrane.Time.microsecond/1","type":"function"},{"doc":"Returns given amount of microseconds in Membrane.Time units.","ref":"Membrane.Time.html#microseconds/1","title":"Membrane.Time.microseconds/1","type":"function"},{"doc":"Returns one millisecond in Membrane.Time units.","ref":"Membrane.Time.html#millisecond/0","title":"Membrane.Time.millisecond/0","type":"function"},{"doc":"","ref":"Membrane.Time.html#millisecond/1","title":"Membrane.Time.millisecond/1","type":"function"},{"doc":"Returns given amount of milliseconds in Membrane.Time units.","ref":"Membrane.Time.html#milliseconds/1","title":"Membrane.Time.milliseconds/1","type":"function"},{"doc":"Returns one minute in Membrane.Time units.","ref":"Membrane.Time.html#minute/0","title":"Membrane.Time.minute/0","type":"function"},{"doc":"","ref":"Membrane.Time.html#minute/1","title":"Membrane.Time.minute/1","type":"function"},{"doc":"Returns given amount of minutes in Membrane.Time units.","ref":"Membrane.Time.html#minutes/1","title":"Membrane.Time.minutes/1","type":"function"},{"doc":"Returns current monotonic time based on System.monotonic_time/0 in Membrane.Time units.","ref":"Membrane.Time.html#monotonic_time/0","title":"Membrane.Time.monotonic_time/0","type":"function"},{"doc":"Returns one nanosecond in Membrane.Time units.","ref":"Membrane.Time.html#nanosecond/0","title":"Membrane.Time.nanosecond/0","type":"function"},{"doc":"","ref":"Membrane.Time.html#nanosecond/1","title":"Membrane.Time.nanosecond/1","type":"function"},{"doc":"Returns given amount of nanoseconds in Membrane.Time units.","ref":"Membrane.Time.html#nanoseconds/1","title":"Membrane.Time.nanoseconds/1","type":"function"},{"doc":"Returns one VM native unit in Membrane.Time units.","ref":"Membrane.Time.html#native_unit/0","title":"Membrane.Time.native_unit/0","type":"function"},{"doc":"","ref":"Membrane.Time.html#native_unit/1","title":"Membrane.Time.native_unit/1","type":"function"},{"doc":"Returns given amount of VM native units in Membrane.Time units.","ref":"Membrane.Time.html#native_units/1","title":"Membrane.Time.native_units/1","type":"function"},{"doc":"Returns current POSIX time of operating system based on System.os_time/0 in Membrane.Time units.This time is not monotonic.","ref":"Membrane.Time.html#os_time/0","title":"Membrane.Time.os_time/0","type":"function"},{"doc":"Returns duration as a string with unit. Chosen unit is the biggest possible that doesn't involve precission loss.Examplesiex&gt; import Membrane.Time iex&gt; 10 |&gt; milliseconds() |&gt; pretty_duration() &quot;10 ms&quot; iex&gt; 60_000_000 |&gt; microseconds() |&gt; pretty_duration() &quot;1 min&quot; iex&gt; 2 |&gt; nanoseconds() |&gt; pretty_duration() &quot;2 ns&quot;","ref":"Membrane.Time.html#pretty_duration/1","title":"Membrane.Time.pretty_duration/1","type":"function"},{"doc":"Returns current time in pretty format (currently iso8601), as string Uses system_time/0 under the hood.","ref":"Membrane.Time.html#pretty_now/0","title":"Membrane.Time.pretty_now/0","type":"function"},{"doc":"Returns one second in Membrane.Time units.","ref":"Membrane.Time.html#second/0","title":"Membrane.Time.second/0","type":"function"},{"doc":"","ref":"Membrane.Time.html#second/1","title":"Membrane.Time.second/1","type":"function"},{"doc":"Returns given amount of seconds in Membrane.Time units.","ref":"Membrane.Time.html#seconds/1","title":"Membrane.Time.seconds/1","type":"function"},{"doc":"Returns current time of Erlang VM based on System.system_time/0 in Membrane.Time units.","ref":"Membrane.Time.html#system_time/0","title":"Membrane.Time.system_time/0","type":"function"},{"doc":"Returns quoted code producing given amount time. Chosen unit is the biggest possible that doesn't involve precission loss.Examplesiex&gt; import Membrane.Time iex&gt; 10 |&gt; milliseconds() |&gt; to_code() |&gt; Macro.to_string() quote do 10 |&gt; Membrane.Time.milliseconds() end |&gt; Macro.to_string() iex&gt; 60_000_000 |&gt; microseconds() |&gt; to_code() |&gt; Macro.to_string() quote do Membrane.Time.minute() end |&gt; Macro.to_string() iex&gt; 2 |&gt; nanoseconds() |&gt; to_code() |&gt; Macro.to_string() quote do 2 |&gt; Membrane.Time.nanoseconds() end |&gt; Macro.to_string()","ref":"Membrane.Time.html#to_code/1","title":"Membrane.Time.to_code/1","type":"function"},{"doc":"Returns string representation of result of to_code/1.","ref":"Membrane.Time.html#to_code_str/1","title":"Membrane.Time.to_code_str/1","type":"function"},{"doc":"Returns time as a DateTime struct. TimeZone is set to UTC.","ref":"Membrane.Time.html#to_datetime/1","title":"Membrane.Time.to_datetime/1","type":"function"},{"doc":"Returns time in days. Rounded using Kernel.round/1.","ref":"Membrane.Time.html#to_days/1","title":"Membrane.Time.to_days/1","type":"function"},{"doc":"Returns time in hours. Rounded using Kernel.round/1.","ref":"Membrane.Time.html#to_hours/1","title":"Membrane.Time.to_hours/1","type":"function"},{"doc":"Returns time as a iso8601 string.","ref":"Membrane.Time.html#to_iso8601/1","title":"Membrane.Time.to_iso8601/1","type":"function"},{"doc":"Returns time in microseconds. Rounded using Kernel.round/1.","ref":"Membrane.Time.html#to_microseconds/1","title":"Membrane.Time.to_microseconds/1","type":"function"},{"doc":"Returns time in milliseconds. Rounded using Kernel.round/1.","ref":"Membrane.Time.html#to_milliseconds/1","title":"Membrane.Time.to_milliseconds/1","type":"function"},{"doc":"Returns time in minutes. Rounded using Kernel.round/1.","ref":"Membrane.Time.html#to_minutes/1","title":"Membrane.Time.to_minutes/1","type":"function"},{"doc":"Returns time in nanoseconds. Rounded using Kernel.round/1.","ref":"Membrane.Time.html#to_nanoseconds/1","title":"Membrane.Time.to_nanoseconds/1","type":"function"},{"doc":"Returns time in VM native units. Rounded using Kernel.round/1.","ref":"Membrane.Time.html#to_native_units/1","title":"Membrane.Time.to_native_units/1","type":"function"},{"doc":"Converts the timestamp into NTP timestamp. May introduce small rounding errors.","ref":"Membrane.Time.html#to_ntp_timestamp/1","title":"Membrane.Time.to_ntp_timestamp/1","type":"function"},{"doc":"Returns time in seconds. Rounded using Kernel.round/1.","ref":"Membrane.Time.html#to_seconds/1","title":"Membrane.Time.to_seconds/1","type":"function"},{"doc":"Returns current Erlang VM system time based on System.system_time/0 in Membrane.Time units.It is the VM view of the os_time/0. They may not match in case of time warps. It is not monotonic.","ref":"Membrane.Time.html#vm_time/0","title":"Membrane.Time.vm_time/0","type":"function"},{"doc":"","ref":"Membrane.Time.html#t:non_neg_t/0","title":"Membrane.Time.non_neg_t/0","type":"type"},{"doc":"","ref":"Membrane.Time.html#t:t/0","title":"Membrane.Time.t/0","type":"type"},{"doc":"","ref":"Membrane.ActionError.html","title":"Membrane.ActionError","type":"exception"},{"doc":"","ref":"Membrane.CallbackError.html","title":"Membrane.CallbackError","type":"exception"},{"doc":"","ref":"Membrane.LinkError.html","title":"Membrane.LinkError","type":"exception"},{"doc":"","ref":"Membrane.ParentError.html","title":"Membrane.ParentError","type":"exception"},{"doc":"","ref":"Membrane.PipelineError.html","title":"Membrane.PipelineError","type":"exception"},{"doc":"Mixin for logging using simple functions such as info/1, debug/1 in other modules.","ref":"Membrane.Log.html","title":"Membrane.Log","type":"module"},{"doc":"","ref":"Membrane.Log.html#debug/2","title":"Membrane.Log.debug/2","type":"macro"},{"doc":"","ref":"Membrane.Log.html#info/2","title":"Membrane.Log.info/2","type":"macro"},{"doc":"","ref":"Membrane.Log.html#log/3","title":"Membrane.Log.log/3","type":"macro"},{"doc":"","ref":"Membrane.Log.html#or_warn_error/3","title":"Membrane.Log.or_warn_error/3","type":"macro"},{"doc":"","ref":"Membrane.Log.html#warn/2","title":"Membrane.Log.warn/2","type":"macro"},{"doc":"","ref":"Membrane.Log.html#warn_error/3","title":"Membrane.Log.warn_error/3","type":"macro"},{"doc":"","ref":"Membrane.Log.html#t:level_t/0","title":"Membrane.Log.level_t/0","type":"type"},{"doc":"Module containing functions spawning, shutting down, and handling messages sent to logger.","ref":"Membrane.Log.Logger.html","title":"Membrane.Log.Logger","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Membrane.Log.Logger.html#child_spec/1","title":"Membrane.Log.Logger.child_spec/1","type":"function"},{"doc":"Stops given logger process.It will wait for reply for amount of time passed as second argument (in milliseconds).Will trigger calling handle_shutdown/2 logger callback.Returns :ok.","ref":"Membrane.Log.Logger.html#shutdown/2","title":"Membrane.Log.Logger.shutdown/2","type":"function"},{"doc":"Starts process for logger of given module, initialized with given options outside of the supervision tree.Works similarly to GenServer.start/3 and has the same return values.","ref":"Membrane.Log.Logger.html#start/3","title":"Membrane.Log.Logger.start/3","type":"function"},{"doc":"Starts process for logger of given module, initialized with given options and links it to the current process in the supervision tree.Works similarly to GenServer.start_link/3 and has the same return values.","ref":"Membrane.Log.Logger.html#start_link/3","title":"Membrane.Log.Logger.start_link/3","type":"function"},{"doc":"","ref":"Membrane.Log.Logger.html#t:logger_options_t/0","title":"Membrane.Log.Logger.logger_options_t/0","type":"type"},{"doc":"","ref":"Membrane.Log.Logger.html#t:message_t/0","title":"Membrane.Log.Logger.message_t/0","type":"type"},{"doc":"","ref":"Membrane.Log.Logger.html#t:msg_level_t/0","title":"Membrane.Log.Logger.msg_level_t/0","type":"type"},{"doc":"","ref":"Membrane.Log.Logger.html#t:on_start/0","title":"Membrane.Log.Logger.on_start/0","type":"type"},{"doc":"","ref":"Membrane.Log.Logger.html#t:process_options_t/0","title":"Membrane.Log.Logger.process_options_t/0","type":"type"},{"doc":"","ref":"Membrane.Log.Logger.html#t:tag_t/0","title":"Membrane.Log.Logger.tag_t/0","type":"type"},{"doc":"This is a base module used by all logger implementations.","ref":"Membrane.Log.Logger.Base.html","title":"Membrane.Log.Logger.Base","type":"behaviour"},{"doc":"Callback invoked when logger is initialized, right after new process is spawned.On success it should return {:ok, initial_logger_state}.","ref":"Membrane.Log.Logger.Base.html#c:handle_init/1","title":"Membrane.Log.Logger.Base.handle_init/1","type":"callback"},{"doc":"Callback invoked when new log message is received.Callback delivers 5 arguments:atom containing log levelmessage - in IO list formattimetags (list of atoms, e.g. module name)internal logger stateOn success, it returns {:ok, new_state}. it will just update logger's state to the new state.If it returns {:error, reason, new_state} it indicates that something went wrong, and logger was unable to handle log. State will be updated to the new state.","ref":"Membrane.Log.Logger.Base.html#c:handle_log/5","title":"Membrane.Log.Logger.Base.handle_log/5","type":"callback"},{"doc":"Callback invoked when logger is shutting down just before process is exiting. It will receive the logger state.Return value is ignored.","ref":"Membrane.Log.Logger.Base.html#c:handle_shutdown/1","title":"Membrane.Log.Logger.Base.handle_shutdown/1","type":"callback"},{"doc":"Defines a router that dispatches logs to instances of Membrane.Log.Logger.Base","ref":"Membrane.Log.Router.html","title":"Membrane.Log.Router","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Membrane.Log.Router.html#child_spec/1","title":"Membrane.Log.Router.child_spec/1","type":"function"},{"doc":"Converts atom with level to its number representationValid atoms are::debug:info:warn","ref":"Membrane.Log.Router.html#level_to_val/1","title":"Membrane.Log.Router.level_to_val/1","type":"function"},{"doc":"Sends asynchronous call to the router, requesting it to forward log message to appropriate loggers.This functions assumes that passed log has level equal or greater than global level.","ref":"Membrane.Log.Router.html#send_log/4","title":"Membrane.Log.Router.send_log/4","type":"function"},{"doc":"Starts router as a separate process.Options are passed to Supervisor.start_link/3.","ref":"Membrane.Log.Router.html#start_link/1","title":"Membrane.Log.Router.start_link/1","type":"function"},{"doc":"Module responsible for supervising router_level loggers. It is also responsible for receiving and routing log messages to appropriate loggers.It is spawned upon application boot.","ref":"Membrane.Log.Supervisor.html","title":"Membrane.Log.Supervisor","type":"module"},{"doc":"Initializes logger and adds it to the supervision tree.As arguments, it expects module name, logger options and process/logger idIf successful returns :ok On error returns :invalid_module","ref":"Membrane.Log.Supervisor.html#add_logger/3","title":"Membrane.Log.Supervisor.add_logger/3","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Membrane.Log.Supervisor.html#child_spec/1","title":"Membrane.Log.Supervisor.child_spec/1","type":"function"},{"doc":"Iterates through list of children and executes given function on every child.Should return :ok.","ref":"Membrane.Log.Supervisor.html#each_logger/1","title":"Membrane.Log.Supervisor.each_logger/1","type":"function"},{"doc":"Removes logger from the supervision treeIf successful returns :ok If logger could not be found, returns corresponding error","ref":"Membrane.Log.Supervisor.html#remove_logger/1","title":"Membrane.Log.Supervisor.remove_logger/1","type":"function"},{"doc":"Starts the Supervisor.Options are passed to Supervisor.start_link/3.","ref":"Membrane.Log.Supervisor.html#start_link/2","title":"Membrane.Log.Supervisor.start_link/2","type":"function"},{"doc":"","ref":"Membrane.Log.Supervisor.html#t:child_id_t/0","title":"Membrane.Log.Supervisor.child_id_t/0","type":"type"},{"doc":"Membrane Multimedia Framework Membrane Framework - if you asked me what it is, I have no idea. - Jose Valim in ElixirConf 2018 KeynoteMultimedia processing framework that focuses on reliability, concurrency and scalability.An easy to use abstraction layer for assembling mostly server-side applications that have to consume, produce or process multimedia streams.It puts reliability over amount of features.It is written in Elixir + C with outstanding Erlang VM underneath that gives us a rock solid and battle tested foundation.","ref":"readme.html","title":"Membrane Multimedia Framework","type":"extras"},{"doc":"This package provides core of the Membrane Multimedia Framework.","ref":"readme.html#membrane-core","title":"Membrane Multimedia Framework - Membrane Core","type":"extras"},{"doc":"Add the following line to your deps in mix.exs. Run mix deps.get.{:membrane_core, &quot;~&gt; 0.6.1&quot;}","ref":"readme.html#installation","title":"Membrane Multimedia Framework - Installation","type":"extras"},{"doc":"To get familiar with basic concepts and build your first application using Membrane Framework, visit Membrane Guide.API documentation is available at HexDocs","ref":"readme.html#getting-started","title":"Membrane Multimedia Framework - Getting started","type":"extras"},{"doc":"Any contributions are more than welcome! You can help us improving Membrane by either contributing to the core (see opened issues), extending our guide or by creating new elements.For more details see Contribution guide","ref":"readme.html#contributing","title":"Membrane Multimedia Framework - Contributing","type":"extras"},{"doc":"If you have any problems with Membrane Framework feel free to contact us via membrane tag at Elixir forum, mailing list, Discord or via e-mail.","ref":"readme.html#support-and-questions","title":"Membrane Multimedia Framework - Support and questions","type":"extras"},{"doc":"Copyright 2018, Software MansionLicensed under the Apache License, Version 2.0","ref":"readme.html#copyright-and-license","title":"Membrane Multimedia Framework - Copyright and License","type":"extras"},{"doc":"ContributingAny contributions to Membrane Framework are welcome. If you would like contribute, but you're not sure how to start or have some questions, don't hesitate to contact us via channels described in READMEBefore subitting code please read our Coding style guideWhen contributing to existing repo:fork itapply change on some branchcreate a PR from fork to our repoawait feedback from someone from the teamafter passing the review, the PR will be mergedIf you wish to create a new plugin you can give us a shout and if it's something we want as a part of our ecosystem we'll create a repo for you, guide you on your work and maintain the plugin in future.However, if feel confident enough to maintain it on your own, you can, of course, create your own repo and hex package - we only ask you to follow the naming convetions of the framework package and modules. In that case, don't forget to let us know about your work so we could include it on the list of available plugins.","ref":"contributing.html","title":"Contributing","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright 2018 Software Mansion Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"License","type":"extras"}]